<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfExpandedLineResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfExpandedLineResult extends AbstractStructArrayBase
{
    /**
     * The ExpandedLineResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ExpandedLineResult[]
     */
    public $ExpandedLineResult;
    /**
     * Constructor method for ArrayOfExpandedLineResult
     * @uses ArrayOfExpandedLineResult::setExpandedLineResult()
     * @param \StructType\ExpandedLineResult[] $expandedLineResult
     */
    public function __construct(array $expandedLineResult = array())
    {
        $this
            ->setExpandedLineResult($expandedLineResult);
    }
    /**
     * Get ExpandedLineResult value
     * @return \StructType\ExpandedLineResult[]|null
     */
    public function getExpandedLineResult()
    {
        return $this->ExpandedLineResult;
    }
    /**
     * This method is responsible for validating the values passed to the setExpandedLineResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExpandedLineResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExpandedLineResultForArrayConstraintsFromSetExpandedLineResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfExpandedLineResultExpandedLineResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfExpandedLineResultExpandedLineResultItem instanceof \StructType\ExpandedLineResult) {
                $invalidValues[] = is_object($arrayOfExpandedLineResultExpandedLineResultItem) ? get_class($arrayOfExpandedLineResultExpandedLineResultItem) : sprintf('%s(%s)', gettype($arrayOfExpandedLineResultExpandedLineResultItem), var_export($arrayOfExpandedLineResultExpandedLineResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ExpandedLineResult property can only contain items of type \StructType\ExpandedLineResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ExpandedLineResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ExpandedLineResult[] $expandedLineResult
     * @return \ArrayType\ArrayOfExpandedLineResult
     */
    public function setExpandedLineResult(array $expandedLineResult = array())
    {
        // validation for constraint: array
        if ('' !== ($expandedLineResultArrayErrorMessage = self::validateExpandedLineResultForArrayConstraintsFromSetExpandedLineResult($expandedLineResult))) {
            throw new \InvalidArgumentException($expandedLineResultArrayErrorMessage, __LINE__);
        }
        $this->ExpandedLineResult = $expandedLineResult;
        return $this;
    }
    /**
     * Add item to ExpandedLineResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ExpandedLineResult $item
     * @return \ArrayType\ArrayOfExpandedLineResult
     */
    public function addToExpandedLineResult(\StructType\ExpandedLineResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ExpandedLineResult) {
            throw new \InvalidArgumentException(sprintf('The ExpandedLineResult property can only contain items of type \StructType\ExpandedLineResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ExpandedLineResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ExpandedLineResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ExpandedLineResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ExpandedLineResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ExpandedLineResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ExpandedLineResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ExpandedLineResult
     */
    public function getAttributeName()
    {
        return 'ExpandedLineResult';
    }
}
