<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGoodsReceivedNotificationLine ArrayType
 * @subpackage Arrays
 */
class ArrayOfGoodsReceivedNotificationLine extends AbstractStructArrayBase
{
    /**
     * The GoodsReceivedNotificationLine
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GoodsReceivedNotificationLine[]
     */
    public $GoodsReceivedNotificationLine;
    /**
     * Constructor method for ArrayOfGoodsReceivedNotificationLine
     * @uses ArrayOfGoodsReceivedNotificationLine::setGoodsReceivedNotificationLine()
     * @param \StructType\GoodsReceivedNotificationLine[] $goodsReceivedNotificationLine
     */
    public function __construct(array $goodsReceivedNotificationLine = array())
    {
        $this
            ->setGoodsReceivedNotificationLine($goodsReceivedNotificationLine);
    }
    /**
     * Get GoodsReceivedNotificationLine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GoodsReceivedNotificationLine[]|null
     */
    public function getGoodsReceivedNotificationLine()
    {
        return isset($this->GoodsReceivedNotificationLine) ? $this->GoodsReceivedNotificationLine : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGoodsReceivedNotificationLine method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGoodsReceivedNotificationLine method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGoodsReceivedNotificationLineForArrayConstraintsFromSetGoodsReceivedNotificationLine(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGoodsReceivedNotificationLineGoodsReceivedNotificationLineItem) {
            // validation for constraint: itemType
            if (!$arrayOfGoodsReceivedNotificationLineGoodsReceivedNotificationLineItem instanceof \StructType\GoodsReceivedNotificationLine) {
                $invalidValues[] = is_object($arrayOfGoodsReceivedNotificationLineGoodsReceivedNotificationLineItem) ? get_class($arrayOfGoodsReceivedNotificationLineGoodsReceivedNotificationLineItem) : sprintf('%s(%s)', gettype($arrayOfGoodsReceivedNotificationLineGoodsReceivedNotificationLineItem), var_export($arrayOfGoodsReceivedNotificationLineGoodsReceivedNotificationLineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GoodsReceivedNotificationLine property can only contain items of type \StructType\GoodsReceivedNotificationLine, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GoodsReceivedNotificationLine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GoodsReceivedNotificationLine[] $goodsReceivedNotificationLine
     * @return \ArrayType\ArrayOfGoodsReceivedNotificationLine
     */
    public function setGoodsReceivedNotificationLine(array $goodsReceivedNotificationLine = array())
    {
        // validation for constraint: array
        if ('' !== ($goodsReceivedNotificationLineArrayErrorMessage = self::validateGoodsReceivedNotificationLineForArrayConstraintsFromSetGoodsReceivedNotificationLine($goodsReceivedNotificationLine))) {
            throw new \InvalidArgumentException($goodsReceivedNotificationLineArrayErrorMessage, __LINE__);
        }
        if (is_null($goodsReceivedNotificationLine) || (is_array($goodsReceivedNotificationLine) && empty($goodsReceivedNotificationLine))) {
            unset($this->GoodsReceivedNotificationLine);
        } else {
            $this->GoodsReceivedNotificationLine = $goodsReceivedNotificationLine;
        }
        return $this;
    }
    /**
     * Add item to GoodsReceivedNotificationLine value
     * @throws \InvalidArgumentException
     * @param \StructType\GoodsReceivedNotificationLine $item
     * @return \ArrayType\ArrayOfGoodsReceivedNotificationLine
     */
    public function addToGoodsReceivedNotificationLine(\StructType\GoodsReceivedNotificationLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GoodsReceivedNotificationLine) {
            throw new \InvalidArgumentException(sprintf('The GoodsReceivedNotificationLine property can only contain items of type \StructType\GoodsReceivedNotificationLine, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GoodsReceivedNotificationLine[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GoodsReceivedNotificationLine|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GoodsReceivedNotificationLine|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GoodsReceivedNotificationLine|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GoodsReceivedNotificationLine|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GoodsReceivedNotificationLine|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GoodsReceivedNotificationLine
     */
    public function getAttributeName()
    {
        return 'GoodsReceivedNotificationLine';
    }
}
