<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPurchaseOrderLine ArrayType
 * @subpackage Arrays
 */
class ArrayOfPurchaseOrderLine extends AbstractStructArrayBase
{
    /**
     * The PurchaseOrderLine
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PurchaseOrderLine[]
     */
    public $PurchaseOrderLine;
    /**
     * Constructor method for ArrayOfPurchaseOrderLine
     * @uses ArrayOfPurchaseOrderLine::setPurchaseOrderLine()
     * @param \StructType\PurchaseOrderLine[] $purchaseOrderLine
     */
    public function __construct(array $purchaseOrderLine = array())
    {
        $this
            ->setPurchaseOrderLine($purchaseOrderLine);
    }
    /**
     * Get PurchaseOrderLine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PurchaseOrderLine[]|null
     */
    public function getPurchaseOrderLine()
    {
        return isset($this->PurchaseOrderLine) ? $this->PurchaseOrderLine : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPurchaseOrderLine method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPurchaseOrderLine method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePurchaseOrderLineForArrayConstraintsFromSetPurchaseOrderLine(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPurchaseOrderLinePurchaseOrderLineItem) {
            // validation for constraint: itemType
            if (!$arrayOfPurchaseOrderLinePurchaseOrderLineItem instanceof \StructType\PurchaseOrderLine) {
                $invalidValues[] = is_object($arrayOfPurchaseOrderLinePurchaseOrderLineItem) ? get_class($arrayOfPurchaseOrderLinePurchaseOrderLineItem) : sprintf('%s(%s)', gettype($arrayOfPurchaseOrderLinePurchaseOrderLineItem), var_export($arrayOfPurchaseOrderLinePurchaseOrderLineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PurchaseOrderLine property can only contain items of type \StructType\PurchaseOrderLine, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PurchaseOrderLine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PurchaseOrderLine[] $purchaseOrderLine
     * @return \ArrayType\ArrayOfPurchaseOrderLine
     */
    public function setPurchaseOrderLine(array $purchaseOrderLine = array())
    {
        // validation for constraint: array
        if ('' !== ($purchaseOrderLineArrayErrorMessage = self::validatePurchaseOrderLineForArrayConstraintsFromSetPurchaseOrderLine($purchaseOrderLine))) {
            throw new \InvalidArgumentException($purchaseOrderLineArrayErrorMessage, __LINE__);
        }
        if (is_null($purchaseOrderLine) || (is_array($purchaseOrderLine) && empty($purchaseOrderLine))) {
            unset($this->PurchaseOrderLine);
        } else {
            $this->PurchaseOrderLine = $purchaseOrderLine;
        }
        return $this;
    }
    /**
     * Add item to PurchaseOrderLine value
     * @throws \InvalidArgumentException
     * @param \StructType\PurchaseOrderLine $item
     * @return \ArrayType\ArrayOfPurchaseOrderLine
     */
    public function addToPurchaseOrderLine(\StructType\PurchaseOrderLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PurchaseOrderLine) {
            throw new \InvalidArgumentException(sprintf('The PurchaseOrderLine property can only contain items of type \StructType\PurchaseOrderLine, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PurchaseOrderLine[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PurchaseOrderLine|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PurchaseOrderLine|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PurchaseOrderLine|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PurchaseOrderLine|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PurchaseOrderLine|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PurchaseOrderLine
     */
    public function getAttributeName()
    {
        return 'PurchaseOrderLine';
    }
}
