<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiApplyVendorCreditItemResponse ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiApplyVendorCreditItemResponse extends AbstractStructArrayBase
{
    /**
     * The TipaltiApplyVendorCreditItemResponse
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiApplyVendorCreditItemResponse[]
     */
    public $TipaltiApplyVendorCreditItemResponse;
    /**
     * Constructor method for ArrayOfTipaltiApplyVendorCreditItemResponse
     * @uses ArrayOfTipaltiApplyVendorCreditItemResponse::setTipaltiApplyVendorCreditItemResponse()
     * @param \StructType\TipaltiApplyVendorCreditItemResponse[] $tipaltiApplyVendorCreditItemResponse
     */
    public function __construct(array $tipaltiApplyVendorCreditItemResponse = array())
    {
        $this
            ->setTipaltiApplyVendorCreditItemResponse($tipaltiApplyVendorCreditItemResponse);
    }
    /**
     * Get TipaltiApplyVendorCreditItemResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiApplyVendorCreditItemResponse[]|null
     */
    public function getTipaltiApplyVendorCreditItemResponse()
    {
        return isset($this->TipaltiApplyVendorCreditItemResponse) ? $this->TipaltiApplyVendorCreditItemResponse : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiApplyVendorCreditItemResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiApplyVendorCreditItemResponse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiApplyVendorCreditItemResponseForArrayConstraintsFromSetTipaltiApplyVendorCreditItemResponse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiApplyVendorCreditItemResponseTipaltiApplyVendorCreditItemResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiApplyVendorCreditItemResponseTipaltiApplyVendorCreditItemResponseItem instanceof \StructType\TipaltiApplyVendorCreditItemResponse) {
                $invalidValues[] = is_object($arrayOfTipaltiApplyVendorCreditItemResponseTipaltiApplyVendorCreditItemResponseItem) ? get_class($arrayOfTipaltiApplyVendorCreditItemResponseTipaltiApplyVendorCreditItemResponseItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiApplyVendorCreditItemResponseTipaltiApplyVendorCreditItemResponseItem), var_export($arrayOfTipaltiApplyVendorCreditItemResponseTipaltiApplyVendorCreditItemResponseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiApplyVendorCreditItemResponse property can only contain items of type \StructType\TipaltiApplyVendorCreditItemResponse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiApplyVendorCreditItemResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiApplyVendorCreditItemResponse[] $tipaltiApplyVendorCreditItemResponse
     * @return \ArrayType\ArrayOfTipaltiApplyVendorCreditItemResponse
     */
    public function setTipaltiApplyVendorCreditItemResponse(array $tipaltiApplyVendorCreditItemResponse = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiApplyVendorCreditItemResponseArrayErrorMessage = self::validateTipaltiApplyVendorCreditItemResponseForArrayConstraintsFromSetTipaltiApplyVendorCreditItemResponse($tipaltiApplyVendorCreditItemResponse))) {
            throw new \InvalidArgumentException($tipaltiApplyVendorCreditItemResponseArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiApplyVendorCreditItemResponse) || (is_array($tipaltiApplyVendorCreditItemResponse) && empty($tipaltiApplyVendorCreditItemResponse))) {
            unset($this->TipaltiApplyVendorCreditItemResponse);
        } else {
            $this->TipaltiApplyVendorCreditItemResponse = $tipaltiApplyVendorCreditItemResponse;
        }
        return $this;
    }
    /**
     * Add item to TipaltiApplyVendorCreditItemResponse value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiApplyVendorCreditItemResponse $item
     * @return \ArrayType\ArrayOfTipaltiApplyVendorCreditItemResponse
     */
    public function addToTipaltiApplyVendorCreditItemResponse(\StructType\TipaltiApplyVendorCreditItemResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiApplyVendorCreditItemResponse) {
            throw new \InvalidArgumentException(sprintf('The TipaltiApplyVendorCreditItemResponse property can only contain items of type \StructType\TipaltiApplyVendorCreditItemResponse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiApplyVendorCreditItemResponse[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiApplyVendorCreditItemResponse|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiApplyVendorCreditItemResponse|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiApplyVendorCreditItemResponse|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiApplyVendorCreditItemResponse|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiApplyVendorCreditItemResponse|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiApplyVendorCreditItemResponse
     */
    public function getAttributeName()
    {
        return 'TipaltiApplyVendorCreditItemResponse';
    }
}
