<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiCustomField ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiCustomField extends AbstractStructArrayBase
{
    /**
     * The TipaltiCustomField
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiCustomField[]
     */
    public $TipaltiCustomField;
    /**
     * Constructor method for ArrayOfTipaltiCustomField
     * @uses ArrayOfTipaltiCustomField::setTipaltiCustomField()
     * @param \StructType\TipaltiCustomField[] $tipaltiCustomField
     */
    public function __construct(array $tipaltiCustomField = array())
    {
        $this
            ->setTipaltiCustomField($tipaltiCustomField);
    }
    /**
     * Get TipaltiCustomField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiCustomField[]|null
     */
    public function getTipaltiCustomField()
    {
        return isset($this->TipaltiCustomField) ? $this->TipaltiCustomField : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiCustomField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiCustomField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiCustomFieldForArrayConstraintsFromSetTipaltiCustomField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiCustomFieldTipaltiCustomFieldItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiCustomFieldTipaltiCustomFieldItem instanceof \StructType\TipaltiCustomField) {
                $invalidValues[] = is_object($arrayOfTipaltiCustomFieldTipaltiCustomFieldItem) ? get_class($arrayOfTipaltiCustomFieldTipaltiCustomFieldItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiCustomFieldTipaltiCustomFieldItem), var_export($arrayOfTipaltiCustomFieldTipaltiCustomFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiCustomField property can only contain items of type \StructType\TipaltiCustomField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiCustomField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiCustomField[] $tipaltiCustomField
     * @return \ArrayType\ArrayOfTipaltiCustomField
     */
    public function setTipaltiCustomField(array $tipaltiCustomField = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiCustomFieldArrayErrorMessage = self::validateTipaltiCustomFieldForArrayConstraintsFromSetTipaltiCustomField($tipaltiCustomField))) {
            throw new \InvalidArgumentException($tipaltiCustomFieldArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiCustomField) || (is_array($tipaltiCustomField) && empty($tipaltiCustomField))) {
            unset($this->TipaltiCustomField);
        } else {
            $this->TipaltiCustomField = $tipaltiCustomField;
        }
        return $this;
    }
    /**
     * Add item to TipaltiCustomField value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiCustomField $item
     * @return \ArrayType\ArrayOfTipaltiCustomField
     */
    public function addToTipaltiCustomField(\StructType\TipaltiCustomField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiCustomField) {
            throw new \InvalidArgumentException(sprintf('The TipaltiCustomField property can only contain items of type \StructType\TipaltiCustomField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiCustomField[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiCustomField|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiCustomField|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiCustomField|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiCustomField|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiCustomField|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiCustomField
     */
    public function getAttributeName()
    {
        return 'TipaltiCustomField';
    }
}
