<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiCustomFieldUpdateResponse ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiCustomFieldUpdateResponse extends AbstractStructArrayBase
{
    /**
     * The TipaltiCustomFieldUpdateResponse
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiCustomFieldUpdateResponse[]
     */
    public $TipaltiCustomFieldUpdateResponse;
    /**
     * Constructor method for ArrayOfTipaltiCustomFieldUpdateResponse
     * @uses ArrayOfTipaltiCustomFieldUpdateResponse::setTipaltiCustomFieldUpdateResponse()
     * @param \StructType\TipaltiCustomFieldUpdateResponse[] $tipaltiCustomFieldUpdateResponse
     */
    public function __construct(array $tipaltiCustomFieldUpdateResponse = array())
    {
        $this
            ->setTipaltiCustomFieldUpdateResponse($tipaltiCustomFieldUpdateResponse);
    }
    /**
     * Get TipaltiCustomFieldUpdateResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiCustomFieldUpdateResponse[]|null
     */
    public function getTipaltiCustomFieldUpdateResponse()
    {
        return isset($this->TipaltiCustomFieldUpdateResponse) ? $this->TipaltiCustomFieldUpdateResponse : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiCustomFieldUpdateResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiCustomFieldUpdateResponse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiCustomFieldUpdateResponseForArrayConstraintsFromSetTipaltiCustomFieldUpdateResponse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiCustomFieldUpdateResponseTipaltiCustomFieldUpdateResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiCustomFieldUpdateResponseTipaltiCustomFieldUpdateResponseItem instanceof \StructType\TipaltiCustomFieldUpdateResponse) {
                $invalidValues[] = is_object($arrayOfTipaltiCustomFieldUpdateResponseTipaltiCustomFieldUpdateResponseItem) ? get_class($arrayOfTipaltiCustomFieldUpdateResponseTipaltiCustomFieldUpdateResponseItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiCustomFieldUpdateResponseTipaltiCustomFieldUpdateResponseItem), var_export($arrayOfTipaltiCustomFieldUpdateResponseTipaltiCustomFieldUpdateResponseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiCustomFieldUpdateResponse property can only contain items of type \StructType\TipaltiCustomFieldUpdateResponse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiCustomFieldUpdateResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiCustomFieldUpdateResponse[] $tipaltiCustomFieldUpdateResponse
     * @return \ArrayType\ArrayOfTipaltiCustomFieldUpdateResponse
     */
    public function setTipaltiCustomFieldUpdateResponse(array $tipaltiCustomFieldUpdateResponse = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiCustomFieldUpdateResponseArrayErrorMessage = self::validateTipaltiCustomFieldUpdateResponseForArrayConstraintsFromSetTipaltiCustomFieldUpdateResponse($tipaltiCustomFieldUpdateResponse))) {
            throw new \InvalidArgumentException($tipaltiCustomFieldUpdateResponseArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiCustomFieldUpdateResponse) || (is_array($tipaltiCustomFieldUpdateResponse) && empty($tipaltiCustomFieldUpdateResponse))) {
            unset($this->TipaltiCustomFieldUpdateResponse);
        } else {
            $this->TipaltiCustomFieldUpdateResponse = $tipaltiCustomFieldUpdateResponse;
        }
        return $this;
    }
    /**
     * Add item to TipaltiCustomFieldUpdateResponse value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiCustomFieldUpdateResponse $item
     * @return \ArrayType\ArrayOfTipaltiCustomFieldUpdateResponse
     */
    public function addToTipaltiCustomFieldUpdateResponse(\StructType\TipaltiCustomFieldUpdateResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiCustomFieldUpdateResponse) {
            throw new \InvalidArgumentException(sprintf('The TipaltiCustomFieldUpdateResponse property can only contain items of type \StructType\TipaltiCustomFieldUpdateResponse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiCustomFieldUpdateResponse[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiCustomFieldUpdateResponse|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiCustomFieldUpdateResponse|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiCustomFieldUpdateResponse|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiCustomFieldUpdateResponse|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiCustomFieldUpdateResponse|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiCustomFieldUpdateResponse
     */
    public function getAttributeName()
    {
        return 'TipaltiCustomFieldUpdateResponse';
    }
}
