<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiFee ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiFee extends AbstractStructArrayBase
{
    /**
     * The TipaltiFee
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiFee[]
     */
    public $TipaltiFee;
    /**
     * Constructor method for ArrayOfTipaltiFee
     * @uses ArrayOfTipaltiFee::setTipaltiFee()
     * @param \StructType\TipaltiFee[] $tipaltiFee
     */
    public function __construct(array $tipaltiFee = array())
    {
        $this
            ->setTipaltiFee($tipaltiFee);
    }
    /**
     * Get TipaltiFee value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiFee[]|null
     */
    public function getTipaltiFee()
    {
        return isset($this->TipaltiFee) ? $this->TipaltiFee : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiFee method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiFee method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiFeeForArrayConstraintsFromSetTipaltiFee(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiFeeTipaltiFeeItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiFeeTipaltiFeeItem instanceof \StructType\TipaltiFee) {
                $invalidValues[] = is_object($arrayOfTipaltiFeeTipaltiFeeItem) ? get_class($arrayOfTipaltiFeeTipaltiFeeItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiFeeTipaltiFeeItem), var_export($arrayOfTipaltiFeeTipaltiFeeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiFee property can only contain items of type \StructType\TipaltiFee, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiFee value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiFee[] $tipaltiFee
     * @return \ArrayType\ArrayOfTipaltiFee
     */
    public function setTipaltiFee(array $tipaltiFee = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiFeeArrayErrorMessage = self::validateTipaltiFeeForArrayConstraintsFromSetTipaltiFee($tipaltiFee))) {
            throw new \InvalidArgumentException($tipaltiFeeArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiFee) || (is_array($tipaltiFee) && empty($tipaltiFee))) {
            unset($this->TipaltiFee);
        } else {
            $this->TipaltiFee = $tipaltiFee;
        }
        return $this;
    }
    /**
     * Add item to TipaltiFee value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiFee $item
     * @return \ArrayType\ArrayOfTipaltiFee
     */
    public function addToTipaltiFee(\StructType\TipaltiFee $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiFee) {
            throw new \InvalidArgumentException(sprintf('The TipaltiFee property can only contain items of type \StructType\TipaltiFee, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiFee[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiFee|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiFee|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiFee|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiFee|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiFee|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiFee
     */
    public function getAttributeName()
    {
        return 'TipaltiFee';
    }
}
