<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiGrnItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiGrnItem extends AbstractStructArrayBase
{
    /**
     * The TipaltiGrnItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiGrnItem[]
     */
    public $TipaltiGrnItem;
    /**
     * Constructor method for ArrayOfTipaltiGrnItem
     * @uses ArrayOfTipaltiGrnItem::setTipaltiGrnItem()
     * @param \StructType\TipaltiGrnItem[] $tipaltiGrnItem
     */
    public function __construct(array $tipaltiGrnItem = array())
    {
        $this
            ->setTipaltiGrnItem($tipaltiGrnItem);
    }
    /**
     * Get TipaltiGrnItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiGrnItem[]|null
     */
    public function getTipaltiGrnItem()
    {
        return isset($this->TipaltiGrnItem) ? $this->TipaltiGrnItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiGrnItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiGrnItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiGrnItemForArrayConstraintsFromSetTipaltiGrnItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiGrnItemTipaltiGrnItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiGrnItemTipaltiGrnItemItem instanceof \StructType\TipaltiGrnItem) {
                $invalidValues[] = is_object($arrayOfTipaltiGrnItemTipaltiGrnItemItem) ? get_class($arrayOfTipaltiGrnItemTipaltiGrnItemItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiGrnItemTipaltiGrnItemItem), var_export($arrayOfTipaltiGrnItemTipaltiGrnItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiGrnItem property can only contain items of type \StructType\TipaltiGrnItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiGrnItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiGrnItem[] $tipaltiGrnItem
     * @return \ArrayType\ArrayOfTipaltiGrnItem
     */
    public function setTipaltiGrnItem(array $tipaltiGrnItem = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiGrnItemArrayErrorMessage = self::validateTipaltiGrnItemForArrayConstraintsFromSetTipaltiGrnItem($tipaltiGrnItem))) {
            throw new \InvalidArgumentException($tipaltiGrnItemArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiGrnItem) || (is_array($tipaltiGrnItem) && empty($tipaltiGrnItem))) {
            unset($this->TipaltiGrnItem);
        } else {
            $this->TipaltiGrnItem = $tipaltiGrnItem;
        }
        return $this;
    }
    /**
     * Add item to TipaltiGrnItem value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiGrnItem $item
     * @return \ArrayType\ArrayOfTipaltiGrnItem
     */
    public function addToTipaltiGrnItem(\StructType\TipaltiGrnItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiGrnItem) {
            throw new \InvalidArgumentException(sprintf('The TipaltiGrnItem property can only contain items of type \StructType\TipaltiGrnItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiGrnItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiGrnItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiGrnItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiGrnItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiGrnItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiGrnItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiGrnItem
     */
    public function getAttributeName()
    {
        return 'TipaltiGrnItem';
    }
}
