<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiGrnItemResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiGrnItemResult extends AbstractStructArrayBase
{
    /**
     * The TipaltiGrnItemResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiGrnItemResult[]
     */
    public $TipaltiGrnItemResult;
    /**
     * Constructor method for ArrayOfTipaltiGrnItemResult
     * @uses ArrayOfTipaltiGrnItemResult::setTipaltiGrnItemResult()
     * @param \StructType\TipaltiGrnItemResult[] $tipaltiGrnItemResult
     */
    public function __construct(array $tipaltiGrnItemResult = array())
    {
        $this
            ->setTipaltiGrnItemResult($tipaltiGrnItemResult);
    }
    /**
     * Get TipaltiGrnItemResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiGrnItemResult[]|null
     */
    public function getTipaltiGrnItemResult()
    {
        return isset($this->TipaltiGrnItemResult) ? $this->TipaltiGrnItemResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiGrnItemResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiGrnItemResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiGrnItemResultForArrayConstraintsFromSetTipaltiGrnItemResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiGrnItemResultTipaltiGrnItemResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiGrnItemResultTipaltiGrnItemResultItem instanceof \StructType\TipaltiGrnItemResult) {
                $invalidValues[] = is_object($arrayOfTipaltiGrnItemResultTipaltiGrnItemResultItem) ? get_class($arrayOfTipaltiGrnItemResultTipaltiGrnItemResultItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiGrnItemResultTipaltiGrnItemResultItem), var_export($arrayOfTipaltiGrnItemResultTipaltiGrnItemResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiGrnItemResult property can only contain items of type \StructType\TipaltiGrnItemResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiGrnItemResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiGrnItemResult[] $tipaltiGrnItemResult
     * @return \ArrayType\ArrayOfTipaltiGrnItemResult
     */
    public function setTipaltiGrnItemResult(array $tipaltiGrnItemResult = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiGrnItemResultArrayErrorMessage = self::validateTipaltiGrnItemResultForArrayConstraintsFromSetTipaltiGrnItemResult($tipaltiGrnItemResult))) {
            throw new \InvalidArgumentException($tipaltiGrnItemResultArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiGrnItemResult) || (is_array($tipaltiGrnItemResult) && empty($tipaltiGrnItemResult))) {
            unset($this->TipaltiGrnItemResult);
        } else {
            $this->TipaltiGrnItemResult = $tipaltiGrnItemResult;
        }
        return $this;
    }
    /**
     * Add item to TipaltiGrnItemResult value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiGrnItemResult $item
     * @return \ArrayType\ArrayOfTipaltiGrnItemResult
     */
    public function addToTipaltiGrnItemResult(\StructType\TipaltiGrnItemResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiGrnItemResult) {
            throw new \InvalidArgumentException(sprintf('The TipaltiGrnItemResult property can only contain items of type \StructType\TipaltiGrnItemResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiGrnItemResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiGrnItemResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiGrnItemResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiGrnItemResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiGrnItemResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiGrnItemResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiGrnItemResult
     */
    public function getAttributeName()
    {
        return 'TipaltiGrnItemResult';
    }
}
