<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiInvoiceApprover ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiInvoiceApprover extends AbstractStructArrayBase
{
    /**
     * The TipaltiInvoiceApprover
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiInvoiceApprover[]
     */
    public $TipaltiInvoiceApprover;
    /**
     * Constructor method for ArrayOfTipaltiInvoiceApprover
     * @uses ArrayOfTipaltiInvoiceApprover::setTipaltiInvoiceApprover()
     * @param \StructType\TipaltiInvoiceApprover[] $tipaltiInvoiceApprover
     */
    public function __construct(array $tipaltiInvoiceApprover = array())
    {
        $this
            ->setTipaltiInvoiceApprover($tipaltiInvoiceApprover);
    }
    /**
     * Get TipaltiInvoiceApprover value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiInvoiceApprover[]|null
     */
    public function getTipaltiInvoiceApprover()
    {
        return isset($this->TipaltiInvoiceApprover) ? $this->TipaltiInvoiceApprover : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiInvoiceApprover method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiInvoiceApprover method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiInvoiceApproverForArrayConstraintsFromSetTipaltiInvoiceApprover(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiInvoiceApproverTipaltiInvoiceApproverItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiInvoiceApproverTipaltiInvoiceApproverItem instanceof \StructType\TipaltiInvoiceApprover) {
                $invalidValues[] = is_object($arrayOfTipaltiInvoiceApproverTipaltiInvoiceApproverItem) ? get_class($arrayOfTipaltiInvoiceApproverTipaltiInvoiceApproverItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiInvoiceApproverTipaltiInvoiceApproverItem), var_export($arrayOfTipaltiInvoiceApproverTipaltiInvoiceApproverItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiInvoiceApprover property can only contain items of type \StructType\TipaltiInvoiceApprover, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiInvoiceApprover value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiInvoiceApprover[] $tipaltiInvoiceApprover
     * @return \ArrayType\ArrayOfTipaltiInvoiceApprover
     */
    public function setTipaltiInvoiceApprover(array $tipaltiInvoiceApprover = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiInvoiceApproverArrayErrorMessage = self::validateTipaltiInvoiceApproverForArrayConstraintsFromSetTipaltiInvoiceApprover($tipaltiInvoiceApprover))) {
            throw new \InvalidArgumentException($tipaltiInvoiceApproverArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiInvoiceApprover) || (is_array($tipaltiInvoiceApprover) && empty($tipaltiInvoiceApprover))) {
            unset($this->TipaltiInvoiceApprover);
        } else {
            $this->TipaltiInvoiceApprover = $tipaltiInvoiceApprover;
        }
        return $this;
    }
    /**
     * Add item to TipaltiInvoiceApprover value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiInvoiceApprover $item
     * @return \ArrayType\ArrayOfTipaltiInvoiceApprover
     */
    public function addToTipaltiInvoiceApprover(\StructType\TipaltiInvoiceApprover $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiInvoiceApprover) {
            throw new \InvalidArgumentException(sprintf('The TipaltiInvoiceApprover property can only contain items of type \StructType\TipaltiInvoiceApprover, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiInvoiceApprover[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiInvoiceApprover|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiInvoiceApprover|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiInvoiceApprover|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiInvoiceApprover|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiInvoiceApprover|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiInvoiceApprover
     */
    public function getAttributeName()
    {
        return 'TipaltiInvoiceApprover';
    }
}
