<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiInvoiceItemError ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiInvoiceItemError extends AbstractStructArrayBase
{
    /**
     * The TipaltiInvoiceItemError
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiInvoiceItemError[]
     */
    public $TipaltiInvoiceItemError;
    /**
     * Constructor method for ArrayOfTipaltiInvoiceItemError
     * @uses ArrayOfTipaltiInvoiceItemError::setTipaltiInvoiceItemError()
     * @param \StructType\TipaltiInvoiceItemError[] $tipaltiInvoiceItemError
     */
    public function __construct(array $tipaltiInvoiceItemError = array())
    {
        $this
            ->setTipaltiInvoiceItemError($tipaltiInvoiceItemError);
    }
    /**
     * Get TipaltiInvoiceItemError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiInvoiceItemError[]|null
     */
    public function getTipaltiInvoiceItemError()
    {
        return isset($this->TipaltiInvoiceItemError) ? $this->TipaltiInvoiceItemError : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiInvoiceItemError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiInvoiceItemError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiInvoiceItemErrorForArrayConstraintsFromSetTipaltiInvoiceItemError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiInvoiceItemErrorTipaltiInvoiceItemErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiInvoiceItemErrorTipaltiInvoiceItemErrorItem instanceof \StructType\TipaltiInvoiceItemError) {
                $invalidValues[] = is_object($arrayOfTipaltiInvoiceItemErrorTipaltiInvoiceItemErrorItem) ? get_class($arrayOfTipaltiInvoiceItemErrorTipaltiInvoiceItemErrorItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiInvoiceItemErrorTipaltiInvoiceItemErrorItem), var_export($arrayOfTipaltiInvoiceItemErrorTipaltiInvoiceItemErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiInvoiceItemError property can only contain items of type \StructType\TipaltiInvoiceItemError, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiInvoiceItemError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiInvoiceItemError[] $tipaltiInvoiceItemError
     * @return \ArrayType\ArrayOfTipaltiInvoiceItemError
     */
    public function setTipaltiInvoiceItemError(array $tipaltiInvoiceItemError = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiInvoiceItemErrorArrayErrorMessage = self::validateTipaltiInvoiceItemErrorForArrayConstraintsFromSetTipaltiInvoiceItemError($tipaltiInvoiceItemError))) {
            throw new \InvalidArgumentException($tipaltiInvoiceItemErrorArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiInvoiceItemError) || (is_array($tipaltiInvoiceItemError) && empty($tipaltiInvoiceItemError))) {
            unset($this->TipaltiInvoiceItemError);
        } else {
            $this->TipaltiInvoiceItemError = $tipaltiInvoiceItemError;
        }
        return $this;
    }
    /**
     * Add item to TipaltiInvoiceItemError value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiInvoiceItemError $item
     * @return \ArrayType\ArrayOfTipaltiInvoiceItemError
     */
    public function addToTipaltiInvoiceItemError(\StructType\TipaltiInvoiceItemError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiInvoiceItemError) {
            throw new \InvalidArgumentException(sprintf('The TipaltiInvoiceItemError property can only contain items of type \StructType\TipaltiInvoiceItemError, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiInvoiceItemError[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiInvoiceItemError|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiInvoiceItemError|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiInvoiceItemError|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiInvoiceItemError|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiInvoiceItemError|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiInvoiceItemError
     */
    public function getAttributeName()
    {
        return 'TipaltiInvoiceItemError';
    }
}
