<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiInvoiceItemRequest ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiInvoiceItemRequest extends AbstractStructArrayBase
{
    /**
     * The TipaltiInvoiceItemRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiInvoiceItemRequest[]
     */
    public $TipaltiInvoiceItemRequest;
    /**
     * Constructor method for ArrayOfTipaltiInvoiceItemRequest
     * @uses ArrayOfTipaltiInvoiceItemRequest::setTipaltiInvoiceItemRequest()
     * @param \StructType\TipaltiInvoiceItemRequest[] $tipaltiInvoiceItemRequest
     */
    public function __construct(array $tipaltiInvoiceItemRequest = array())
    {
        $this
            ->setTipaltiInvoiceItemRequest($tipaltiInvoiceItemRequest);
    }
    /**
     * Get TipaltiInvoiceItemRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiInvoiceItemRequest[]|null
     */
    public function getTipaltiInvoiceItemRequest()
    {
        return isset($this->TipaltiInvoiceItemRequest) ? $this->TipaltiInvoiceItemRequest : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiInvoiceItemRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiInvoiceItemRequest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiInvoiceItemRequestForArrayConstraintsFromSetTipaltiInvoiceItemRequest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiInvoiceItemRequestTipaltiInvoiceItemRequestItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiInvoiceItemRequestTipaltiInvoiceItemRequestItem instanceof \StructType\TipaltiInvoiceItemRequest) {
                $invalidValues[] = is_object($arrayOfTipaltiInvoiceItemRequestTipaltiInvoiceItemRequestItem) ? get_class($arrayOfTipaltiInvoiceItemRequestTipaltiInvoiceItemRequestItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiInvoiceItemRequestTipaltiInvoiceItemRequestItem), var_export($arrayOfTipaltiInvoiceItemRequestTipaltiInvoiceItemRequestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiInvoiceItemRequest property can only contain items of type \StructType\TipaltiInvoiceItemRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiInvoiceItemRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiInvoiceItemRequest[] $tipaltiInvoiceItemRequest
     * @return \ArrayType\ArrayOfTipaltiInvoiceItemRequest
     */
    public function setTipaltiInvoiceItemRequest(array $tipaltiInvoiceItemRequest = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiInvoiceItemRequestArrayErrorMessage = self::validateTipaltiInvoiceItemRequestForArrayConstraintsFromSetTipaltiInvoiceItemRequest($tipaltiInvoiceItemRequest))) {
            throw new \InvalidArgumentException($tipaltiInvoiceItemRequestArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiInvoiceItemRequest) || (is_array($tipaltiInvoiceItemRequest) && empty($tipaltiInvoiceItemRequest))) {
            unset($this->TipaltiInvoiceItemRequest);
        } else {
            $this->TipaltiInvoiceItemRequest = $tipaltiInvoiceItemRequest;
        }
        return $this;
    }
    /**
     * Add item to TipaltiInvoiceItemRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiInvoiceItemRequest $item
     * @return \ArrayType\ArrayOfTipaltiInvoiceItemRequest
     */
    public function addToTipaltiInvoiceItemRequest(\StructType\TipaltiInvoiceItemRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiInvoiceItemRequest) {
            throw new \InvalidArgumentException(sprintf('The TipaltiInvoiceItemRequest property can only contain items of type \StructType\TipaltiInvoiceItemRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiInvoiceItemRequest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiInvoiceItemRequest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiInvoiceItemRequest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiInvoiceItemRequest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiInvoiceItemRequest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiInvoiceItemRequest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiInvoiceItemRequest
     */
    public function getAttributeName()
    {
        return 'TipaltiInvoiceItemRequest';
    }
}
