<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiInvoiceItemResponse ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiInvoiceItemResponse extends AbstractStructArrayBase
{
    /**
     * The TipaltiInvoiceItemResponse
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiInvoiceItemResponse[]
     */
    public $TipaltiInvoiceItemResponse;
    /**
     * Constructor method for ArrayOfTipaltiInvoiceItemResponse
     * @uses ArrayOfTipaltiInvoiceItemResponse::setTipaltiInvoiceItemResponse()
     * @param \StructType\TipaltiInvoiceItemResponse[] $tipaltiInvoiceItemResponse
     */
    public function __construct(array $tipaltiInvoiceItemResponse = array())
    {
        $this
            ->setTipaltiInvoiceItemResponse($tipaltiInvoiceItemResponse);
    }
    /**
     * Get TipaltiInvoiceItemResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiInvoiceItemResponse[]|null
     */
    public function getTipaltiInvoiceItemResponse()
    {
        return isset($this->TipaltiInvoiceItemResponse) ? $this->TipaltiInvoiceItemResponse : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiInvoiceItemResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiInvoiceItemResponse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiInvoiceItemResponseForArrayConstraintsFromSetTipaltiInvoiceItemResponse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiInvoiceItemResponseTipaltiInvoiceItemResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiInvoiceItemResponseTipaltiInvoiceItemResponseItem instanceof \StructType\TipaltiInvoiceItemResponse) {
                $invalidValues[] = is_object($arrayOfTipaltiInvoiceItemResponseTipaltiInvoiceItemResponseItem) ? get_class($arrayOfTipaltiInvoiceItemResponseTipaltiInvoiceItemResponseItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiInvoiceItemResponseTipaltiInvoiceItemResponseItem), var_export($arrayOfTipaltiInvoiceItemResponseTipaltiInvoiceItemResponseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiInvoiceItemResponse property can only contain items of type \StructType\TipaltiInvoiceItemResponse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiInvoiceItemResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiInvoiceItemResponse[] $tipaltiInvoiceItemResponse
     * @return \ArrayType\ArrayOfTipaltiInvoiceItemResponse
     */
    public function setTipaltiInvoiceItemResponse(array $tipaltiInvoiceItemResponse = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiInvoiceItemResponseArrayErrorMessage = self::validateTipaltiInvoiceItemResponseForArrayConstraintsFromSetTipaltiInvoiceItemResponse($tipaltiInvoiceItemResponse))) {
            throw new \InvalidArgumentException($tipaltiInvoiceItemResponseArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiInvoiceItemResponse) || (is_array($tipaltiInvoiceItemResponse) && empty($tipaltiInvoiceItemResponse))) {
            unset($this->TipaltiInvoiceItemResponse);
        } else {
            $this->TipaltiInvoiceItemResponse = $tipaltiInvoiceItemResponse;
        }
        return $this;
    }
    /**
     * Add item to TipaltiInvoiceItemResponse value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiInvoiceItemResponse $item
     * @return \ArrayType\ArrayOfTipaltiInvoiceItemResponse
     */
    public function addToTipaltiInvoiceItemResponse(\StructType\TipaltiInvoiceItemResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiInvoiceItemResponse) {
            throw new \InvalidArgumentException(sprintf('The TipaltiInvoiceItemResponse property can only contain items of type \StructType\TipaltiInvoiceItemResponse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiInvoiceItemResponse[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiInvoiceItemResponse|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiInvoiceItemResponse|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiInvoiceItemResponse|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiInvoiceItemResponse|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiInvoiceItemResponse|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiInvoiceItemResponse
     */
    public function getAttributeName()
    {
        return 'TipaltiInvoiceItemResponse';
    }
}
