<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiInvoiceItemResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiInvoiceItemResult extends AbstractStructArrayBase
{
    /**
     * The TipaltiInvoiceItemResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiInvoiceItemResult[]
     */
    public $TipaltiInvoiceItemResult;
    /**
     * Constructor method for ArrayOfTipaltiInvoiceItemResult
     * @uses ArrayOfTipaltiInvoiceItemResult::setTipaltiInvoiceItemResult()
     * @param \StructType\TipaltiInvoiceItemResult[] $tipaltiInvoiceItemResult
     */
    public function __construct(array $tipaltiInvoiceItemResult = array())
    {
        $this
            ->setTipaltiInvoiceItemResult($tipaltiInvoiceItemResult);
    }
    /**
     * Get TipaltiInvoiceItemResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiInvoiceItemResult[]|null
     */
    public function getTipaltiInvoiceItemResult()
    {
        return isset($this->TipaltiInvoiceItemResult) ? $this->TipaltiInvoiceItemResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiInvoiceItemResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiInvoiceItemResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiInvoiceItemResultForArrayConstraintsFromSetTipaltiInvoiceItemResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiInvoiceItemResultTipaltiInvoiceItemResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiInvoiceItemResultTipaltiInvoiceItemResultItem instanceof \StructType\TipaltiInvoiceItemResult) {
                $invalidValues[] = is_object($arrayOfTipaltiInvoiceItemResultTipaltiInvoiceItemResultItem) ? get_class($arrayOfTipaltiInvoiceItemResultTipaltiInvoiceItemResultItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiInvoiceItemResultTipaltiInvoiceItemResultItem), var_export($arrayOfTipaltiInvoiceItemResultTipaltiInvoiceItemResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiInvoiceItemResult property can only contain items of type \StructType\TipaltiInvoiceItemResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiInvoiceItemResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiInvoiceItemResult[] $tipaltiInvoiceItemResult
     * @return \ArrayType\ArrayOfTipaltiInvoiceItemResult
     */
    public function setTipaltiInvoiceItemResult(array $tipaltiInvoiceItemResult = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiInvoiceItemResultArrayErrorMessage = self::validateTipaltiInvoiceItemResultForArrayConstraintsFromSetTipaltiInvoiceItemResult($tipaltiInvoiceItemResult))) {
            throw new \InvalidArgumentException($tipaltiInvoiceItemResultArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiInvoiceItemResult) || (is_array($tipaltiInvoiceItemResult) && empty($tipaltiInvoiceItemResult))) {
            unset($this->TipaltiInvoiceItemResult);
        } else {
            $this->TipaltiInvoiceItemResult = $tipaltiInvoiceItemResult;
        }
        return $this;
    }
    /**
     * Add item to TipaltiInvoiceItemResult value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiInvoiceItemResult $item
     * @return \ArrayType\ArrayOfTipaltiInvoiceItemResult
     */
    public function addToTipaltiInvoiceItemResult(\StructType\TipaltiInvoiceItemResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiInvoiceItemResult) {
            throw new \InvalidArgumentException(sprintf('The TipaltiInvoiceItemResult property can only contain items of type \StructType\TipaltiInvoiceItemResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiInvoiceItemResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiInvoiceItemResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiInvoiceItemResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiInvoiceItemResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiInvoiceItemResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiInvoiceItemResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiInvoiceItemResult
     */
    public function getAttributeName()
    {
        return 'TipaltiInvoiceItemResult';
    }
}
