<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiPaymentOrderItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiPaymentOrderItem extends AbstractStructArrayBase
{
    /**
     * The TipaltiPaymentOrderItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiPaymentOrderItem[]
     */
    public $TipaltiPaymentOrderItem;
    /**
     * Constructor method for ArrayOfTipaltiPaymentOrderItem
     * @uses ArrayOfTipaltiPaymentOrderItem::setTipaltiPaymentOrderItem()
     * @param \StructType\TipaltiPaymentOrderItem[] $tipaltiPaymentOrderItem
     */
    public function __construct(array $tipaltiPaymentOrderItem = array())
    {
        $this
            ->setTipaltiPaymentOrderItem($tipaltiPaymentOrderItem);
    }
    /**
     * Get TipaltiPaymentOrderItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiPaymentOrderItem[]|null
     */
    public function getTipaltiPaymentOrderItem()
    {
        return isset($this->TipaltiPaymentOrderItem) ? $this->TipaltiPaymentOrderItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiPaymentOrderItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiPaymentOrderItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiPaymentOrderItemForArrayConstraintsFromSetTipaltiPaymentOrderItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiPaymentOrderItemTipaltiPaymentOrderItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiPaymentOrderItemTipaltiPaymentOrderItemItem instanceof \StructType\TipaltiPaymentOrderItem) {
                $invalidValues[] = is_object($arrayOfTipaltiPaymentOrderItemTipaltiPaymentOrderItemItem) ? get_class($arrayOfTipaltiPaymentOrderItemTipaltiPaymentOrderItemItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiPaymentOrderItemTipaltiPaymentOrderItemItem), var_export($arrayOfTipaltiPaymentOrderItemTipaltiPaymentOrderItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiPaymentOrderItem property can only contain items of type \StructType\TipaltiPaymentOrderItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiPaymentOrderItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiPaymentOrderItem[] $tipaltiPaymentOrderItem
     * @return \ArrayType\ArrayOfTipaltiPaymentOrderItem
     */
    public function setTipaltiPaymentOrderItem(array $tipaltiPaymentOrderItem = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiPaymentOrderItemArrayErrorMessage = self::validateTipaltiPaymentOrderItemForArrayConstraintsFromSetTipaltiPaymentOrderItem($tipaltiPaymentOrderItem))) {
            throw new \InvalidArgumentException($tipaltiPaymentOrderItemArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiPaymentOrderItem) || (is_array($tipaltiPaymentOrderItem) && empty($tipaltiPaymentOrderItem))) {
            unset($this->TipaltiPaymentOrderItem);
        } else {
            $this->TipaltiPaymentOrderItem = $tipaltiPaymentOrderItem;
        }
        return $this;
    }
    /**
     * Add item to TipaltiPaymentOrderItem value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiPaymentOrderItem $item
     * @return \ArrayType\ArrayOfTipaltiPaymentOrderItem
     */
    public function addToTipaltiPaymentOrderItem(\StructType\TipaltiPaymentOrderItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiPaymentOrderItem) {
            throw new \InvalidArgumentException(sprintf('The TipaltiPaymentOrderItem property can only contain items of type \StructType\TipaltiPaymentOrderItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiPaymentOrderItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiPaymentOrderItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiPaymentOrderItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiPaymentOrderItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiPaymentOrderItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiPaymentOrderItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiPaymentOrderItem
     */
    public function getAttributeName()
    {
        return 'TipaltiPaymentOrderItem';
    }
}
