<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiPaymentTerm ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiPaymentTerm extends AbstractStructArrayBase
{
    /**
     * The TipaltiPaymentTerm
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiPaymentTerm[]
     */
    public $TipaltiPaymentTerm;
    /**
     * Constructor method for ArrayOfTipaltiPaymentTerm
     * @uses ArrayOfTipaltiPaymentTerm::setTipaltiPaymentTerm()
     * @param \StructType\TipaltiPaymentTerm[] $tipaltiPaymentTerm
     */
    public function __construct(array $tipaltiPaymentTerm = array())
    {
        $this
            ->setTipaltiPaymentTerm($tipaltiPaymentTerm);
    }
    /**
     * Get TipaltiPaymentTerm value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiPaymentTerm[]|null
     */
    public function getTipaltiPaymentTerm()
    {
        return isset($this->TipaltiPaymentTerm) ? $this->TipaltiPaymentTerm : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiPaymentTerm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiPaymentTerm method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiPaymentTermForArrayConstraintsFromSetTipaltiPaymentTerm(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiPaymentTermTipaltiPaymentTermItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiPaymentTermTipaltiPaymentTermItem instanceof \StructType\TipaltiPaymentTerm) {
                $invalidValues[] = is_object($arrayOfTipaltiPaymentTermTipaltiPaymentTermItem) ? get_class($arrayOfTipaltiPaymentTermTipaltiPaymentTermItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiPaymentTermTipaltiPaymentTermItem), var_export($arrayOfTipaltiPaymentTermTipaltiPaymentTermItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiPaymentTerm property can only contain items of type \StructType\TipaltiPaymentTerm, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiPaymentTerm value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiPaymentTerm[] $tipaltiPaymentTerm
     * @return \ArrayType\ArrayOfTipaltiPaymentTerm
     */
    public function setTipaltiPaymentTerm(array $tipaltiPaymentTerm = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiPaymentTermArrayErrorMessage = self::validateTipaltiPaymentTermForArrayConstraintsFromSetTipaltiPaymentTerm($tipaltiPaymentTerm))) {
            throw new \InvalidArgumentException($tipaltiPaymentTermArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiPaymentTerm) || (is_array($tipaltiPaymentTerm) && empty($tipaltiPaymentTerm))) {
            unset($this->TipaltiPaymentTerm);
        } else {
            $this->TipaltiPaymentTerm = $tipaltiPaymentTerm;
        }
        return $this;
    }
    /**
     * Add item to TipaltiPaymentTerm value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiPaymentTerm $item
     * @return \ArrayType\ArrayOfTipaltiPaymentTerm
     */
    public function addToTipaltiPaymentTerm(\StructType\TipaltiPaymentTerm $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiPaymentTerm) {
            throw new \InvalidArgumentException(sprintf('The TipaltiPaymentTerm property can only contain items of type \StructType\TipaltiPaymentTerm, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiPaymentTerm[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiPaymentTerm|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiPaymentTerm|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiPaymentTerm|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiPaymentTerm|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiPaymentTerm|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiPaymentTerm
     */
    public function getAttributeName()
    {
        return 'TipaltiPaymentTerm';
    }
}
