<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiProcessPaymentsSummary ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiProcessPaymentsSummary extends AbstractStructArrayBase
{
    /**
     * The TipaltiProcessPaymentsSummary
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiProcessPaymentsSummary[]
     */
    public $TipaltiProcessPaymentsSummary;
    /**
     * Constructor method for ArrayOfTipaltiProcessPaymentsSummary
     * @uses ArrayOfTipaltiProcessPaymentsSummary::setTipaltiProcessPaymentsSummary()
     * @param \StructType\TipaltiProcessPaymentsSummary[] $tipaltiProcessPaymentsSummary
     */
    public function __construct(array $tipaltiProcessPaymentsSummary = array())
    {
        $this
            ->setTipaltiProcessPaymentsSummary($tipaltiProcessPaymentsSummary);
    }
    /**
     * Get TipaltiProcessPaymentsSummary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiProcessPaymentsSummary[]|null
     */
    public function getTipaltiProcessPaymentsSummary()
    {
        return isset($this->TipaltiProcessPaymentsSummary) ? $this->TipaltiProcessPaymentsSummary : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiProcessPaymentsSummary method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiProcessPaymentsSummary method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiProcessPaymentsSummaryForArrayConstraintsFromSetTipaltiProcessPaymentsSummary(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiProcessPaymentsSummaryTipaltiProcessPaymentsSummaryItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiProcessPaymentsSummaryTipaltiProcessPaymentsSummaryItem instanceof \StructType\TipaltiProcessPaymentsSummary) {
                $invalidValues[] = is_object($arrayOfTipaltiProcessPaymentsSummaryTipaltiProcessPaymentsSummaryItem) ? get_class($arrayOfTipaltiProcessPaymentsSummaryTipaltiProcessPaymentsSummaryItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiProcessPaymentsSummaryTipaltiProcessPaymentsSummaryItem), var_export($arrayOfTipaltiProcessPaymentsSummaryTipaltiProcessPaymentsSummaryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiProcessPaymentsSummary property can only contain items of type \StructType\TipaltiProcessPaymentsSummary, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiProcessPaymentsSummary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiProcessPaymentsSummary[] $tipaltiProcessPaymentsSummary
     * @return \ArrayType\ArrayOfTipaltiProcessPaymentsSummary
     */
    public function setTipaltiProcessPaymentsSummary(array $tipaltiProcessPaymentsSummary = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiProcessPaymentsSummaryArrayErrorMessage = self::validateTipaltiProcessPaymentsSummaryForArrayConstraintsFromSetTipaltiProcessPaymentsSummary($tipaltiProcessPaymentsSummary))) {
            throw new \InvalidArgumentException($tipaltiProcessPaymentsSummaryArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiProcessPaymentsSummary) || (is_array($tipaltiProcessPaymentsSummary) && empty($tipaltiProcessPaymentsSummary))) {
            unset($this->TipaltiProcessPaymentsSummary);
        } else {
            $this->TipaltiProcessPaymentsSummary = $tipaltiProcessPaymentsSummary;
        }
        return $this;
    }
    /**
     * Add item to TipaltiProcessPaymentsSummary value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiProcessPaymentsSummary $item
     * @return \ArrayType\ArrayOfTipaltiProcessPaymentsSummary
     */
    public function addToTipaltiProcessPaymentsSummary(\StructType\TipaltiProcessPaymentsSummary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiProcessPaymentsSummary) {
            throw new \InvalidArgumentException(sprintf('The TipaltiProcessPaymentsSummary property can only contain items of type \StructType\TipaltiProcessPaymentsSummary, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiProcessPaymentsSummary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiProcessPaymentsSummary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiProcessPaymentsSummary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiProcessPaymentsSummary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiProcessPaymentsSummary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiProcessPaymentsSummary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiProcessPaymentsSummary
     */
    public function getAttributeName()
    {
        return 'TipaltiProcessPaymentsSummary';
    }
}
