<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiPurchaseOrderItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiPurchaseOrderItem extends AbstractStructArrayBase
{
    /**
     * The TipaltiPurchaseOrderItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiPurchaseOrderItem[]
     */
    public $TipaltiPurchaseOrderItem;
    /**
     * Constructor method for ArrayOfTipaltiPurchaseOrderItem
     * @uses ArrayOfTipaltiPurchaseOrderItem::setTipaltiPurchaseOrderItem()
     * @param \StructType\TipaltiPurchaseOrderItem[] $tipaltiPurchaseOrderItem
     */
    public function __construct(array $tipaltiPurchaseOrderItem = array())
    {
        $this
            ->setTipaltiPurchaseOrderItem($tipaltiPurchaseOrderItem);
    }
    /**
     * Get TipaltiPurchaseOrderItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiPurchaseOrderItem[]|null
     */
    public function getTipaltiPurchaseOrderItem()
    {
        return isset($this->TipaltiPurchaseOrderItem) ? $this->TipaltiPurchaseOrderItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiPurchaseOrderItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiPurchaseOrderItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiPurchaseOrderItemForArrayConstraintsFromSetTipaltiPurchaseOrderItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiPurchaseOrderItemTipaltiPurchaseOrderItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiPurchaseOrderItemTipaltiPurchaseOrderItemItem instanceof \StructType\TipaltiPurchaseOrderItem) {
                $invalidValues[] = is_object($arrayOfTipaltiPurchaseOrderItemTipaltiPurchaseOrderItemItem) ? get_class($arrayOfTipaltiPurchaseOrderItemTipaltiPurchaseOrderItemItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiPurchaseOrderItemTipaltiPurchaseOrderItemItem), var_export($arrayOfTipaltiPurchaseOrderItemTipaltiPurchaseOrderItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiPurchaseOrderItem property can only contain items of type \StructType\TipaltiPurchaseOrderItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiPurchaseOrderItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiPurchaseOrderItem[] $tipaltiPurchaseOrderItem
     * @return \ArrayType\ArrayOfTipaltiPurchaseOrderItem
     */
    public function setTipaltiPurchaseOrderItem(array $tipaltiPurchaseOrderItem = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiPurchaseOrderItemArrayErrorMessage = self::validateTipaltiPurchaseOrderItemForArrayConstraintsFromSetTipaltiPurchaseOrderItem($tipaltiPurchaseOrderItem))) {
            throw new \InvalidArgumentException($tipaltiPurchaseOrderItemArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiPurchaseOrderItem) || (is_array($tipaltiPurchaseOrderItem) && empty($tipaltiPurchaseOrderItem))) {
            unset($this->TipaltiPurchaseOrderItem);
        } else {
            $this->TipaltiPurchaseOrderItem = $tipaltiPurchaseOrderItem;
        }
        return $this;
    }
    /**
     * Add item to TipaltiPurchaseOrderItem value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiPurchaseOrderItem $item
     * @return \ArrayType\ArrayOfTipaltiPurchaseOrderItem
     */
    public function addToTipaltiPurchaseOrderItem(\StructType\TipaltiPurchaseOrderItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiPurchaseOrderItem) {
            throw new \InvalidArgumentException(sprintf('The TipaltiPurchaseOrderItem property can only contain items of type \StructType\TipaltiPurchaseOrderItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiPurchaseOrderItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiPurchaseOrderItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiPurchaseOrderItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiPurchaseOrderItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiPurchaseOrderItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiPurchaseOrderItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiPurchaseOrderItem
     */
    public function getAttributeName()
    {
        return 'TipaltiPurchaseOrderItem';
    }
}
