<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiPurchaseOrderItemResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiPurchaseOrderItemResult extends AbstractStructArrayBase
{
    /**
     * The TipaltiPurchaseOrderItemResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiPurchaseOrderItemResult[]
     */
    public $TipaltiPurchaseOrderItemResult;
    /**
     * Constructor method for ArrayOfTipaltiPurchaseOrderItemResult
     * @uses ArrayOfTipaltiPurchaseOrderItemResult::setTipaltiPurchaseOrderItemResult()
     * @param \StructType\TipaltiPurchaseOrderItemResult[] $tipaltiPurchaseOrderItemResult
     */
    public function __construct(array $tipaltiPurchaseOrderItemResult = array())
    {
        $this
            ->setTipaltiPurchaseOrderItemResult($tipaltiPurchaseOrderItemResult);
    }
    /**
     * Get TipaltiPurchaseOrderItemResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiPurchaseOrderItemResult[]|null
     */
    public function getTipaltiPurchaseOrderItemResult()
    {
        return isset($this->TipaltiPurchaseOrderItemResult) ? $this->TipaltiPurchaseOrderItemResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiPurchaseOrderItemResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiPurchaseOrderItemResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiPurchaseOrderItemResultForArrayConstraintsFromSetTipaltiPurchaseOrderItemResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiPurchaseOrderItemResultTipaltiPurchaseOrderItemResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiPurchaseOrderItemResultTipaltiPurchaseOrderItemResultItem instanceof \StructType\TipaltiPurchaseOrderItemResult) {
                $invalidValues[] = is_object($arrayOfTipaltiPurchaseOrderItemResultTipaltiPurchaseOrderItemResultItem) ? get_class($arrayOfTipaltiPurchaseOrderItemResultTipaltiPurchaseOrderItemResultItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiPurchaseOrderItemResultTipaltiPurchaseOrderItemResultItem), var_export($arrayOfTipaltiPurchaseOrderItemResultTipaltiPurchaseOrderItemResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiPurchaseOrderItemResult property can only contain items of type \StructType\TipaltiPurchaseOrderItemResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiPurchaseOrderItemResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiPurchaseOrderItemResult[] $tipaltiPurchaseOrderItemResult
     * @return \ArrayType\ArrayOfTipaltiPurchaseOrderItemResult
     */
    public function setTipaltiPurchaseOrderItemResult(array $tipaltiPurchaseOrderItemResult = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiPurchaseOrderItemResultArrayErrorMessage = self::validateTipaltiPurchaseOrderItemResultForArrayConstraintsFromSetTipaltiPurchaseOrderItemResult($tipaltiPurchaseOrderItemResult))) {
            throw new \InvalidArgumentException($tipaltiPurchaseOrderItemResultArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiPurchaseOrderItemResult) || (is_array($tipaltiPurchaseOrderItemResult) && empty($tipaltiPurchaseOrderItemResult))) {
            unset($this->TipaltiPurchaseOrderItemResult);
        } else {
            $this->TipaltiPurchaseOrderItemResult = $tipaltiPurchaseOrderItemResult;
        }
        return $this;
    }
    /**
     * Add item to TipaltiPurchaseOrderItemResult value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiPurchaseOrderItemResult $item
     * @return \ArrayType\ArrayOfTipaltiPurchaseOrderItemResult
     */
    public function addToTipaltiPurchaseOrderItemResult(\StructType\TipaltiPurchaseOrderItemResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiPurchaseOrderItemResult) {
            throw new \InvalidArgumentException(sprintf('The TipaltiPurchaseOrderItemResult property can only contain items of type \StructType\TipaltiPurchaseOrderItemResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiPurchaseOrderItemResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiPurchaseOrderItemResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiPurchaseOrderItemResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiPurchaseOrderItemResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiPurchaseOrderItemResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiPurchaseOrderItemResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiPurchaseOrderItemResult
     */
    public function getAttributeName()
    {
        return 'TipaltiPurchaseOrderItemResult';
    }
}
