<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiRelatedPurchaseOrder ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiRelatedPurchaseOrder extends AbstractStructArrayBase
{
    /**
     * The TipaltiRelatedPurchaseOrder
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiRelatedPurchaseOrder[]
     */
    public $TipaltiRelatedPurchaseOrder;
    /**
     * Constructor method for ArrayOfTipaltiRelatedPurchaseOrder
     * @uses ArrayOfTipaltiRelatedPurchaseOrder::setTipaltiRelatedPurchaseOrder()
     * @param \StructType\TipaltiRelatedPurchaseOrder[] $tipaltiRelatedPurchaseOrder
     */
    public function __construct(array $tipaltiRelatedPurchaseOrder = array())
    {
        $this
            ->setTipaltiRelatedPurchaseOrder($tipaltiRelatedPurchaseOrder);
    }
    /**
     * Get TipaltiRelatedPurchaseOrder value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiRelatedPurchaseOrder[]|null
     */
    public function getTipaltiRelatedPurchaseOrder()
    {
        return isset($this->TipaltiRelatedPurchaseOrder) ? $this->TipaltiRelatedPurchaseOrder : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiRelatedPurchaseOrder method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiRelatedPurchaseOrder method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiRelatedPurchaseOrderForArrayConstraintsFromSetTipaltiRelatedPurchaseOrder(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiRelatedPurchaseOrderTipaltiRelatedPurchaseOrderItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiRelatedPurchaseOrderTipaltiRelatedPurchaseOrderItem instanceof \StructType\TipaltiRelatedPurchaseOrder) {
                $invalidValues[] = is_object($arrayOfTipaltiRelatedPurchaseOrderTipaltiRelatedPurchaseOrderItem) ? get_class($arrayOfTipaltiRelatedPurchaseOrderTipaltiRelatedPurchaseOrderItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiRelatedPurchaseOrderTipaltiRelatedPurchaseOrderItem), var_export($arrayOfTipaltiRelatedPurchaseOrderTipaltiRelatedPurchaseOrderItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiRelatedPurchaseOrder property can only contain items of type \StructType\TipaltiRelatedPurchaseOrder, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiRelatedPurchaseOrder value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiRelatedPurchaseOrder[] $tipaltiRelatedPurchaseOrder
     * @return \ArrayType\ArrayOfTipaltiRelatedPurchaseOrder
     */
    public function setTipaltiRelatedPurchaseOrder(array $tipaltiRelatedPurchaseOrder = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiRelatedPurchaseOrderArrayErrorMessage = self::validateTipaltiRelatedPurchaseOrderForArrayConstraintsFromSetTipaltiRelatedPurchaseOrder($tipaltiRelatedPurchaseOrder))) {
            throw new \InvalidArgumentException($tipaltiRelatedPurchaseOrderArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiRelatedPurchaseOrder) || (is_array($tipaltiRelatedPurchaseOrder) && empty($tipaltiRelatedPurchaseOrder))) {
            unset($this->TipaltiRelatedPurchaseOrder);
        } else {
            $this->TipaltiRelatedPurchaseOrder = $tipaltiRelatedPurchaseOrder;
        }
        return $this;
    }
    /**
     * Add item to TipaltiRelatedPurchaseOrder value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiRelatedPurchaseOrder $item
     * @return \ArrayType\ArrayOfTipaltiRelatedPurchaseOrder
     */
    public function addToTipaltiRelatedPurchaseOrder(\StructType\TipaltiRelatedPurchaseOrder $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiRelatedPurchaseOrder) {
            throw new \InvalidArgumentException(sprintf('The TipaltiRelatedPurchaseOrder property can only contain items of type \StructType\TipaltiRelatedPurchaseOrder, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiRelatedPurchaseOrder[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiRelatedPurchaseOrder|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiRelatedPurchaseOrder|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiRelatedPurchaseOrder|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiRelatedPurchaseOrder|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiRelatedPurchaseOrder|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiRelatedPurchaseOrder
     */
    public function getAttributeName()
    {
        return 'TipaltiRelatedPurchaseOrder';
    }
}
