<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiSummaryAmounts ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiSummaryAmounts extends AbstractStructArrayBase
{
    /**
     * The TipaltiSummaryAmounts
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiSummaryAmounts[]
     */
    public $TipaltiSummaryAmounts;
    /**
     * Constructor method for ArrayOfTipaltiSummaryAmounts
     * @uses ArrayOfTipaltiSummaryAmounts::setTipaltiSummaryAmounts()
     * @param \StructType\TipaltiSummaryAmounts[] $tipaltiSummaryAmounts
     */
    public function __construct(array $tipaltiSummaryAmounts = array())
    {
        $this
            ->setTipaltiSummaryAmounts($tipaltiSummaryAmounts);
    }
    /**
     * Get TipaltiSummaryAmounts value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiSummaryAmounts[]|null
     */
    public function getTipaltiSummaryAmounts()
    {
        return isset($this->TipaltiSummaryAmounts) ? $this->TipaltiSummaryAmounts : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiSummaryAmounts method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiSummaryAmounts method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiSummaryAmountsForArrayConstraintsFromSetTipaltiSummaryAmounts(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiSummaryAmountsTipaltiSummaryAmountsItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiSummaryAmountsTipaltiSummaryAmountsItem instanceof \StructType\TipaltiSummaryAmounts) {
                $invalidValues[] = is_object($arrayOfTipaltiSummaryAmountsTipaltiSummaryAmountsItem) ? get_class($arrayOfTipaltiSummaryAmountsTipaltiSummaryAmountsItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiSummaryAmountsTipaltiSummaryAmountsItem), var_export($arrayOfTipaltiSummaryAmountsTipaltiSummaryAmountsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiSummaryAmounts property can only contain items of type \StructType\TipaltiSummaryAmounts, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiSummaryAmounts value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiSummaryAmounts[] $tipaltiSummaryAmounts
     * @return \ArrayType\ArrayOfTipaltiSummaryAmounts
     */
    public function setTipaltiSummaryAmounts(array $tipaltiSummaryAmounts = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiSummaryAmountsArrayErrorMessage = self::validateTipaltiSummaryAmountsForArrayConstraintsFromSetTipaltiSummaryAmounts($tipaltiSummaryAmounts))) {
            throw new \InvalidArgumentException($tipaltiSummaryAmountsArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiSummaryAmounts) || (is_array($tipaltiSummaryAmounts) && empty($tipaltiSummaryAmounts))) {
            unset($this->TipaltiSummaryAmounts);
        } else {
            $this->TipaltiSummaryAmounts = $tipaltiSummaryAmounts;
        }
        return $this;
    }
    /**
     * Add item to TipaltiSummaryAmounts value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiSummaryAmounts $item
     * @return \ArrayType\ArrayOfTipaltiSummaryAmounts
     */
    public function addToTipaltiSummaryAmounts(\StructType\TipaltiSummaryAmounts $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiSummaryAmounts) {
            throw new \InvalidArgumentException(sprintf('The TipaltiSummaryAmounts property can only contain items of type \StructType\TipaltiSummaryAmounts, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiSummaryAmounts[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiSummaryAmounts|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiSummaryAmounts|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiSummaryAmounts|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiSummaryAmounts|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiSummaryAmounts|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiSummaryAmounts
     */
    public function getAttributeName()
    {
        return 'TipaltiSummaryAmounts';
    }
}
