<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiTaxCode ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiTaxCode extends AbstractStructArrayBase
{
    /**
     * The TipaltiTaxCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiTaxCode[]
     */
    public $TipaltiTaxCode;
    /**
     * Constructor method for ArrayOfTipaltiTaxCode
     * @uses ArrayOfTipaltiTaxCode::setTipaltiTaxCode()
     * @param \StructType\TipaltiTaxCode[] $tipaltiTaxCode
     */
    public function __construct(array $tipaltiTaxCode = array())
    {
        $this
            ->setTipaltiTaxCode($tipaltiTaxCode);
    }
    /**
     * Get TipaltiTaxCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiTaxCode[]|null
     */
    public function getTipaltiTaxCode()
    {
        return isset($this->TipaltiTaxCode) ? $this->TipaltiTaxCode : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiTaxCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiTaxCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiTaxCodeForArrayConstraintsFromSetTipaltiTaxCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiTaxCodeTipaltiTaxCodeItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiTaxCodeTipaltiTaxCodeItem instanceof \StructType\TipaltiTaxCode) {
                $invalidValues[] = is_object($arrayOfTipaltiTaxCodeTipaltiTaxCodeItem) ? get_class($arrayOfTipaltiTaxCodeTipaltiTaxCodeItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiTaxCodeTipaltiTaxCodeItem), var_export($arrayOfTipaltiTaxCodeTipaltiTaxCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiTaxCode property can only contain items of type \StructType\TipaltiTaxCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiTaxCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiTaxCode[] $tipaltiTaxCode
     * @return \ArrayType\ArrayOfTipaltiTaxCode
     */
    public function setTipaltiTaxCode(array $tipaltiTaxCode = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiTaxCodeArrayErrorMessage = self::validateTipaltiTaxCodeForArrayConstraintsFromSetTipaltiTaxCode($tipaltiTaxCode))) {
            throw new \InvalidArgumentException($tipaltiTaxCodeArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiTaxCode) || (is_array($tipaltiTaxCode) && empty($tipaltiTaxCode))) {
            unset($this->TipaltiTaxCode);
        } else {
            $this->TipaltiTaxCode = $tipaltiTaxCode;
        }
        return $this;
    }
    /**
     * Add item to TipaltiTaxCode value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiTaxCode $item
     * @return \ArrayType\ArrayOfTipaltiTaxCode
     */
    public function addToTipaltiTaxCode(\StructType\TipaltiTaxCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiTaxCode) {
            throw new \InvalidArgumentException(sprintf('The TipaltiTaxCode property can only contain items of type \StructType\TipaltiTaxCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiTaxCode[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiTaxCode|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiTaxCode|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiTaxCode|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiTaxCode|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiTaxCode|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiTaxCode
     */
    public function getAttributeName()
    {
        return 'TipaltiTaxCode';
    }
}
