<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipaltiVendorCredit ArrayType
 * @subpackage Arrays
 */
class ArrayOfTipaltiVendorCredit extends AbstractStructArrayBase
{
    /**
     * The TipaltiVendorCredit
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipaltiVendorCredit[]
     */
    public $TipaltiVendorCredit;
    /**
     * Constructor method for ArrayOfTipaltiVendorCredit
     * @uses ArrayOfTipaltiVendorCredit::setTipaltiVendorCredit()
     * @param \StructType\TipaltiVendorCredit[] $tipaltiVendorCredit
     */
    public function __construct(array $tipaltiVendorCredit = array())
    {
        $this
            ->setTipaltiVendorCredit($tipaltiVendorCredit);
    }
    /**
     * Get TipaltiVendorCredit value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipaltiVendorCredit[]|null
     */
    public function getTipaltiVendorCredit()
    {
        return isset($this->TipaltiVendorCredit) ? $this->TipaltiVendorCredit : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTipaltiVendorCredit method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTipaltiVendorCredit method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTipaltiVendorCreditForArrayConstraintsFromSetTipaltiVendorCredit(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTipaltiVendorCreditTipaltiVendorCreditItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipaltiVendorCreditTipaltiVendorCreditItem instanceof \StructType\TipaltiVendorCredit) {
                $invalidValues[] = is_object($arrayOfTipaltiVendorCreditTipaltiVendorCreditItem) ? get_class($arrayOfTipaltiVendorCreditTipaltiVendorCreditItem) : sprintf('%s(%s)', gettype($arrayOfTipaltiVendorCreditTipaltiVendorCreditItem), var_export($arrayOfTipaltiVendorCreditTipaltiVendorCreditItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TipaltiVendorCredit property can only contain items of type \StructType\TipaltiVendorCredit, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TipaltiVendorCredit value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiVendorCredit[] $tipaltiVendorCredit
     * @return \ArrayType\ArrayOfTipaltiVendorCredit
     */
    public function setTipaltiVendorCredit(array $tipaltiVendorCredit = array())
    {
        // validation for constraint: array
        if ('' !== ($tipaltiVendorCreditArrayErrorMessage = self::validateTipaltiVendorCreditForArrayConstraintsFromSetTipaltiVendorCredit($tipaltiVendorCredit))) {
            throw new \InvalidArgumentException($tipaltiVendorCreditArrayErrorMessage, __LINE__);
        }
        if (is_null($tipaltiVendorCredit) || (is_array($tipaltiVendorCredit) && empty($tipaltiVendorCredit))) {
            unset($this->TipaltiVendorCredit);
        } else {
            $this->TipaltiVendorCredit = $tipaltiVendorCredit;
        }
        return $this;
    }
    /**
     * Add item to TipaltiVendorCredit value
     * @throws \InvalidArgumentException
     * @param \StructType\TipaltiVendorCredit $item
     * @return \ArrayType\ArrayOfTipaltiVendorCredit
     */
    public function addToTipaltiVendorCredit(\StructType\TipaltiVendorCredit $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipaltiVendorCredit) {
            throw new \InvalidArgumentException(sprintf('The TipaltiVendorCredit property can only contain items of type \StructType\TipaltiVendorCredit, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TipaltiVendorCredit[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipaltiVendorCredit|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipaltiVendorCredit|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipaltiVendorCredit|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipaltiVendorCredit|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipaltiVendorCredit|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipaltiVendorCredit
     */
    public function getAttributeName()
    {
        return 'TipaltiVendorCredit';
    }
}
