<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUpdateGLAccountRequest ArrayType
 * @subpackage Arrays
 */
class ArrayOfUpdateGLAccountRequest extends AbstractStructArrayBase
{
    /**
     * The UpdateGLAccountRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UpdateGLAccountRequest[]
     */
    public $UpdateGLAccountRequest;
    /**
     * Constructor method for ArrayOfUpdateGLAccountRequest
     * @uses ArrayOfUpdateGLAccountRequest::setUpdateGLAccountRequest()
     * @param \StructType\UpdateGLAccountRequest[] $updateGLAccountRequest
     */
    public function __construct(array $updateGLAccountRequest = array())
    {
        $this
            ->setUpdateGLAccountRequest($updateGLAccountRequest);
    }
    /**
     * Get UpdateGLAccountRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UpdateGLAccountRequest[]|null
     */
    public function getUpdateGLAccountRequest()
    {
        return isset($this->UpdateGLAccountRequest) ? $this->UpdateGLAccountRequest : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUpdateGLAccountRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpdateGLAccountRequest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpdateGLAccountRequestForArrayConstraintsFromSetUpdateGLAccountRequest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUpdateGLAccountRequestUpdateGLAccountRequestItem) {
            // validation for constraint: itemType
            if (!$arrayOfUpdateGLAccountRequestUpdateGLAccountRequestItem instanceof \StructType\UpdateGLAccountRequest) {
                $invalidValues[] = is_object($arrayOfUpdateGLAccountRequestUpdateGLAccountRequestItem) ? get_class($arrayOfUpdateGLAccountRequestUpdateGLAccountRequestItem) : sprintf('%s(%s)', gettype($arrayOfUpdateGLAccountRequestUpdateGLAccountRequestItem), var_export($arrayOfUpdateGLAccountRequestUpdateGLAccountRequestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UpdateGLAccountRequest property can only contain items of type \StructType\UpdateGLAccountRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UpdateGLAccountRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateGLAccountRequest[] $updateGLAccountRequest
     * @return \ArrayType\ArrayOfUpdateGLAccountRequest
     */
    public function setUpdateGLAccountRequest(array $updateGLAccountRequest = array())
    {
        // validation for constraint: array
        if ('' !== ($updateGLAccountRequestArrayErrorMessage = self::validateUpdateGLAccountRequestForArrayConstraintsFromSetUpdateGLAccountRequest($updateGLAccountRequest))) {
            throw new \InvalidArgumentException($updateGLAccountRequestArrayErrorMessage, __LINE__);
        }
        if (is_null($updateGLAccountRequest) || (is_array($updateGLAccountRequest) && empty($updateGLAccountRequest))) {
            unset($this->UpdateGLAccountRequest);
        } else {
            $this->UpdateGLAccountRequest = $updateGLAccountRequest;
        }
        return $this;
    }
    /**
     * Add item to UpdateGLAccountRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateGLAccountRequest $item
     * @return \ArrayType\ArrayOfUpdateGLAccountRequest
     */
    public function addToUpdateGLAccountRequest(\StructType\UpdateGLAccountRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UpdateGLAccountRequest) {
            throw new \InvalidArgumentException(sprintf('The UpdateGLAccountRequest property can only contain items of type \StructType\UpdateGLAccountRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UpdateGLAccountRequest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UpdateGLAccountRequest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UpdateGLAccountRequest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UpdateGLAccountRequest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UpdateGLAccountRequest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UpdateGLAccountRequest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UpdateGLAccountRequest
     */
    public function getAttributeName()
    {
        return 'UpdateGLAccountRequest';
    }
}
