<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'CreatePaymentOrdersReport' => '\\StructType\\CreatePaymentOrdersReport',
            'CreatePaymentOrdersReportResponse' => '\\StructType\\CreatePaymentOrdersReportResponse',
            'TipaltiReportResponse' => '\\StructType\\TipaltiReportResponse',
            'TestPaymentFile' => '\\StructType\\TestPaymentFile',
            'TestPaymentFileResponse' => '\\StructType\\TestPaymentFileResponse',
            'TipaltiProcessPaymentResponse' => '\\StructType\\TipaltiProcessPaymentResponse',
            'ArrayOfLineErrorOrWarning' => '\\ArrayType\\ArrayOfLineErrorOrWarning',
            'LineErrorOrWarning' => '\\StructType\\LineErrorOrWarning',
            'TestMultiCurrencyPaymentFile' => '\\StructType\\TestMultiCurrencyPaymentFile',
            'TestMultiCurrencyPaymentFileResponse' => '\\StructType\\TestMultiCurrencyPaymentFileResponse',
            'ProcessPaymentFile' => '\\StructType\\ProcessPaymentFile',
            'ProcessPaymentFileResponse' => '\\StructType\\ProcessPaymentFileResponse',
            'GetCustomFields' => '\\StructType\\GetCustomFields',
            'GetCustomFieldsResponse' => '\\StructType\\GetCustomFieldsResponse',
            'TipaltiGetCustomFieldsResponse' => '\\StructType\\TipaltiGetCustomFieldsResponse',
            'ArrayOfCustomFieldInfo' => '\\ArrayType\\ArrayOfCustomFieldInfo',
            'CustomFieldInfo' => '\\StructType\\CustomFieldInfo',
            'ArrayOfCustomFieldValue' => '\\ArrayType\\ArrayOfCustomFieldValue',
            'CustomFieldValue' => '\\StructType\\CustomFieldValue',
            'GetProviderAccounts' => '\\StructType\\GetProviderAccounts',
            'GetProviderAccountsResponse' => '\\StructType\\GetProviderAccountsResponse',
            'TipaltiGetProviderAccountsResponse' => '\\StructType\\TipaltiGetProviderAccountsResponse',
            'ArrayOfAccountInfo' => '\\ArrayType\\ArrayOfAccountInfo',
            'AccountInfo' => '\\StructType\\AccountInfo',
            'ProcessMultiCurrencyPaymentFile' => '\\StructType\\ProcessMultiCurrencyPaymentFile',
            'ProcessMultiCurrencyPaymentFileResponse' => '\\StructType\\ProcessMultiCurrencyPaymentFileResponse',
            'GetDynamicKeyOfSubPayer' => '\\StructType\\GetDynamicKeyOfSubPayer',
            'GetDynamicKeyOfSubPayerResponse' => '\\StructType\\GetDynamicKeyOfSubPayerResponse',
            'TipaltiSubPayerSecurityToken' => '\\StructType\\TipaltiSubPayerSecurityToken',
            'ProcessPayments' => '\\StructType\\ProcessPayments',
            'ArrayOfTipaltiPaymentOrderItem' => '\\ArrayType\\ArrayOfTipaltiPaymentOrderItem',
            'TipaltiPaymentOrderItem' => '\\StructType\\TipaltiPaymentOrderItem',
            'ArrayOfKeyValuePair' => '\\ArrayType\\ArrayOfKeyValuePair',
            'KeyValuePair' => '\\StructType\\KeyValuePair',
            'ProcessPaymentsResponse' => '\\StructType\\ProcessPaymentsResponse',
            'TipaltiExpandedProcessPaymentResponse' => '\\StructType\\TipaltiExpandedProcessPaymentResponse',
            'ArrayOfExpandedLineResult' => '\\ArrayType\\ArrayOfExpandedLineResult',
            'ExpandedLineResult' => '\\StructType\\ExpandedLineResult',
            'ArrayOfTipaltiProcessPaymentsSummary' => '\\ArrayType\\ArrayOfTipaltiProcessPaymentsSummary',
            'TipaltiProcessPaymentsSummary' => '\\StructType\\TipaltiProcessPaymentsSummary',
            'ArrayOfTipaltiSummaryAmounts' => '\\ArrayType\\ArrayOfTipaltiSummaryAmounts',
            'TipaltiSummaryAmounts' => '\\StructType\\TipaltiSummaryAmounts',
            'TestPayments' => '\\StructType\\TestPayments',
            'TestPaymentsResponse' => '\\StructType\\TestPaymentsResponse',
            'ProcessPaymentsAsync' => '\\StructType\\ProcessPaymentsAsync',
            'ProcessPaymentsAsyncResponse' => '\\StructType\\ProcessPaymentsAsyncResponse',
            'TipaltiProcessPaymentAsyncResult' => '\\StructType\\TipaltiProcessPaymentAsyncResult',
            'TestPaymentsAsync' => '\\StructType\\TestPaymentsAsync',
            'TestPaymentsAsyncResponse' => '\\StructType\\TestPaymentsAsyncResponse',
            'ProcessPaymentFileAsync' => '\\StructType\\ProcessPaymentFileAsync',
            'ProcessPaymentFileAsyncResponse' => '\\StructType\\ProcessPaymentFileAsyncResponse',
            'TestPaymentFileAsync' => '\\StructType\\TestPaymentFileAsync',
            'TestPaymentFileAsyncResponse' => '\\StructType\\TestPaymentFileAsyncResponse',
            'TestMultiCurrencyPaymentFileAsync' => '\\StructType\\TestMultiCurrencyPaymentFileAsync',
            'TestMultiCurrencyPaymentFileAsyncResponse' => '\\StructType\\TestMultiCurrencyPaymentFileAsyncResponse',
            'ProcessMultiCurrencyPaymentFileAsync' => '\\StructType\\ProcessMultiCurrencyPaymentFileAsync',
            'ProcessMultiCurrencyPaymentFileAsyncResponse' => '\\StructType\\ProcessMultiCurrencyPaymentFileAsyncResponse',
            'GetProcessingRequestStatus' => '\\StructType\\GetProcessingRequestStatus',
            'GetProcessingRequestStatusResponse' => '\\StructType\\GetProcessingRequestStatusResponse',
            'TipaltiGetProcessingRequestStatusResult' => '\\StructType\\TipaltiGetProcessingRequestStatusResult',
            'ProcessPaymentsAsyncResult' => '\\StructType\\ProcessPaymentsAsyncResult',
            'ProcessPaymentsAsyncResultResponse' => '\\StructType\\ProcessPaymentsAsyncResultResponse',
            'CreateExtendedPayeeStatusFile' => '\\StructType\\CreateExtendedPayeeStatusFile',
            'CreateExtendedPayeeStatusFileResponse' => '\\StructType\\CreateExtendedPayeeStatusFileResponse',
            'TipaltiResponse' => '\\StructType\\TipaltiResponse',
            'CreatePayeeStatusFile' => '\\StructType\\CreatePayeeStatusFile',
            'CreatePayeeStatusFileResponse' => '\\StructType\\CreatePayeeStatusFileResponse',
            'GetDynamicKey' => '\\StructType\\GetDynamicKey',
            'GetDynamicKeyResponse' => '\\StructType\\GetDynamicKeyResponse',
            'SecurityToken' => '\\StructType\\SecurityToken',
            'GetBalances' => '\\StructType\\GetBalances',
            'GetBalancesResponse' => '\\StructType\\GetBalancesResponse',
            'TipaltiGetBalanceResponse' => '\\StructType\\TipaltiGetBalanceResponse',
            'ArrayOfTipaltiAccountInfo' => '\\ArrayType\\ArrayOfTipaltiAccountInfo',
            'TipaltiAccountInfo' => '\\StructType\\TipaltiAccountInfo',
            'GetUpdatedPayments' => '\\StructType\\GetUpdatedPayments',
            'GetUpdatedPaymentsResponse' => '\\StructType\\GetUpdatedPaymentsResponse',
            'TipaltiGetUpdatedPaymentsResponse' => '\\StructType\\TipaltiGetUpdatedPaymentsResponse',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'GetPayerFees' => '\\StructType\\GetPayerFees',
            'GetPayerFeesResponse' => '\\StructType\\GetPayerFeesResponse',
            'TipaltiGetPayerFeesResponse' => '\\StructType\\TipaltiGetPayerFeesResponse',
            'ArrayOfTipaltiFee' => '\\ArrayType\\ArrayOfTipaltiFee',
            'TipaltiFee' => '\\StructType\\TipaltiFee',
            'CreateOrUpdateInvoices' => '\\StructType\\CreateOrUpdateInvoices',
            'ArrayOfTipaltiInvoiceItemRequest' => '\\ArrayType\\ArrayOfTipaltiInvoiceItemRequest',
            'TipaltiInvoiceItemRequest' => '\\StructType\\TipaltiInvoiceItemRequest',
            'ArrayOfInvoiceLine' => '\\ArrayType\\ArrayOfInvoiceLine',
            'InvoiceLine' => '\\StructType\\InvoiceLine',
            'TipaltiGLAccount' => '\\StructType\\TipaltiGLAccount',
            'ArrayOfTipaltiRelatedPurchaseOrder' => '\\ArrayType\\ArrayOfTipaltiRelatedPurchaseOrder',
            'TipaltiRelatedPurchaseOrder' => '\\StructType\\TipaltiRelatedPurchaseOrder',
            'ArrayOfTipaltiInvoiceApprover' => '\\ArrayType\\ArrayOfTipaltiInvoiceApprover',
            'TipaltiInvoiceApprover' => '\\StructType\\TipaltiInvoiceApprover',
            'CreateOrUpdateInvoicesResponse' => '\\StructType\\CreateOrUpdateInvoicesResponse',
            'CreateOrUpdateInvoiceResult' => '\\StructType\\CreateOrUpdateInvoiceResult',
            'ArrayOfTipaltiInvoiceItemResult' => '\\ArrayType\\ArrayOfTipaltiInvoiceItemResult',
            'TipaltiInvoiceItemResult' => '\\StructType\\TipaltiInvoiceItemResult',
            'GetPayeeInvoicesListDetails' => '\\StructType\\GetPayeeInvoicesListDetails',
            'GetPayeeInvoicesListDetailsResponse' => '\\StructType\\GetPayeeInvoicesListDetailsResponse',
            'TipaltiGetPayeeInvoicesListDetailsResponse' => '\\StructType\\TipaltiGetPayeeInvoicesListDetailsResponse',
            'ArrayOfTipaltiInvoiceItemError' => '\\ArrayType\\ArrayOfTipaltiInvoiceItemError',
            'TipaltiInvoiceItemError' => '\\StructType\\TipaltiInvoiceItemError',
            'ArrayOfTipaltiInvoiceItemResponse' => '\\ArrayType\\ArrayOfTipaltiInvoiceItemResponse',
            'TipaltiInvoiceItemResponse' => '\\StructType\\TipaltiInvoiceItemResponse',
            'ArrayOfTipaltiVendorCredit' => '\\ArrayType\\ArrayOfTipaltiVendorCredit',
            'TipaltiVendorCredit' => '\\StructType\\TipaltiVendorCredit',
            'CreateOrUpdateGLAccounts' => '\\StructType\\CreateOrUpdateGLAccounts',
            'ArrayOfUpdateGLAccountRequest' => '\\ArrayType\\ArrayOfUpdateGLAccountRequest',
            'UpdateGLAccountRequest' => '\\StructType\\UpdateGLAccountRequest',
            'CreateOrUpdateGLAccountsResponse' => '\\StructType\\CreateOrUpdateGLAccountsResponse',
            'CreateOrUpdateCustomFields' => '\\StructType\\CreateOrUpdateCustomFields',
            'ArrayOfTipaltiCustomField' => '\\ArrayType\\ArrayOfTipaltiCustomField',
            'TipaltiCustomField' => '\\StructType\\TipaltiCustomField',
            'CreateOrUpdateCustomFieldsResponse' => '\\StructType\\CreateOrUpdateCustomFieldsResponse',
            'TipaltiCustomFieldsUpdateResponse' => '\\StructType\\TipaltiCustomFieldsUpdateResponse',
            'ArrayOfTipaltiCustomFieldUpdateResponse' => '\\ArrayType\\ArrayOfTipaltiCustomFieldUpdateResponse',
            'TipaltiCustomFieldUpdateResponse' => '\\StructType\\TipaltiCustomFieldUpdateResponse',
            'CreateOrUpdateCustomFieldValue' => '\\StructType\\CreateOrUpdateCustomFieldValue',
            'TipaltiCustomFieldValue' => '\\StructType\\TipaltiCustomFieldValue',
            'CreateOrUpdateCustomFieldValueResponse' => '\\StructType\\CreateOrUpdateCustomFieldValueResponse',
            'TipaltiCustomFieldValueUpdateResponse' => '\\StructType\\TipaltiCustomFieldValueUpdateResponse',
            'LogIntegrationError' => '\\StructType\\LogIntegrationError',
            'IntegrationErrorItem' => '\\StructType\\IntegrationErrorItem',
            'LogIntegrationErrorResponse' => '\\StructType\\LogIntegrationErrorResponse',
            'CreateOrUpdateGrns' => '\\StructType\\CreateOrUpdateGrns',
            'ArrayOfTipaltiGrnItem' => '\\ArrayType\\ArrayOfTipaltiGrnItem',
            'TipaltiGrnItem' => '\\StructType\\TipaltiGrnItem',
            'ArrayOfGoodsReceivedNotificationLine' => '\\ArrayType\\ArrayOfGoodsReceivedNotificationLine',
            'GoodsReceivedNotificationLine' => '\\StructType\\GoodsReceivedNotificationLine',
            'CreateOrUpdateGrnsResponse' => '\\StructType\\CreateOrUpdateGrnsResponse',
            'CreateOrUpdateGrnResult' => '\\StructType\\CreateOrUpdateGrnResult',
            'ArrayOfTipaltiGrnItemResult' => '\\ArrayType\\ArrayOfTipaltiGrnItemResult',
            'TipaltiGrnItemResult' => '\\StructType\\TipaltiGrnItemResult',
            'CreateOrUpdatePurchaseOrders' => '\\StructType\\CreateOrUpdatePurchaseOrders',
            'ArrayOfTipaltiPurchaseOrderItem' => '\\ArrayType\\ArrayOfTipaltiPurchaseOrderItem',
            'TipaltiPurchaseOrderItem' => '\\StructType\\TipaltiPurchaseOrderItem',
            'ArrayOfPurchaseOrderLine' => '\\ArrayType\\ArrayOfPurchaseOrderLine',
            'PurchaseOrderLine' => '\\StructType\\PurchaseOrderLine',
            'CreateOrUpdatePurchaseOrdersResponse' => '\\StructType\\CreateOrUpdatePurchaseOrdersResponse',
            'CreateOrUpdatePurchaseOrderResult' => '\\StructType\\CreateOrUpdatePurchaseOrderResult',
            'ArrayOfTipaltiPurchaseOrderItemResult' => '\\ArrayType\\ArrayOfTipaltiPurchaseOrderItemResult',
            'TipaltiPurchaseOrderItemResult' => '\\StructType\\TipaltiPurchaseOrderItemResult',
            'ApplyVendorCredit' => '\\StructType\\ApplyVendorCredit',
            'ArrayOfRelatedInvoice' => '\\ArrayType\\ArrayOfRelatedInvoice',
            'RelatedInvoice' => '\\StructType\\RelatedInvoice',
            'ApplyVendorCreditResponse' => '\\StructType\\ApplyVendorCreditResponse',
            'TipaltiApplyVendorCreditResponse' => '\\StructType\\TipaltiApplyVendorCreditResponse',
            'ArrayOfTipaltiApplyVendorCreditItemResponse' => '\\ArrayType\\ArrayOfTipaltiApplyVendorCreditItemResponse',
            'TipaltiApplyVendorCreditItemResponse' => '\\StructType\\TipaltiApplyVendorCreditItemResponse',
            'CreateOrUpdatePaymentTerms' => '\\StructType\\CreateOrUpdatePaymentTerms',
            'ArrayOfTipaltiPaymentTerm' => '\\ArrayType\\ArrayOfTipaltiPaymentTerm',
            'TipaltiPaymentTerm' => '\\StructType\\TipaltiPaymentTerm',
            'CreateOrUpdatePaymentTermsResponse' => '\\StructType\\CreateOrUpdatePaymentTermsResponse',
            'CreateOrUpdatePaymentTermsResult' => '\\StructType\\CreateOrUpdatePaymentTermsResult',
            'DeletePaymentTerms' => '\\StructType\\DeletePaymentTerms',
            'DeletePaymentTermsResponse' => '\\StructType\\DeletePaymentTermsResponse',
            'DeletePaymentTermsResult' => '\\StructType\\DeletePaymentTermsResult',
            'GetPaymentTerms' => '\\StructType\\GetPaymentTerms',
            'GetPaymentTermsResponse' => '\\StructType\\GetPaymentTermsResponse',
            'GetPaymentTermsResult' => '\\StructType\\GetPaymentTermsResult',
            'CreateOrUpdateTaxCodes' => '\\StructType\\CreateOrUpdateTaxCodes',
            'ArrayOfTipaltiTaxCode' => '\\ArrayType\\ArrayOfTipaltiTaxCode',
            'TipaltiTaxCode' => '\\StructType\\TipaltiTaxCode',
            'CreateOrUpdateTaxCodesResponse' => '\\StructType\\CreateOrUpdateTaxCodesResponse',
            'CreateOrUpdateTaxCodesResult' => '\\StructType\\CreateOrUpdateTaxCodesResult',
            'GetPayerEntities' => '\\StructType\\GetPayerEntities',
            'GetPayerEntitiesResponse' => '\\StructType\\GetPayerEntitiesResponse',
            'GetPayerEntitiesResult' => '\\StructType\\GetPayerEntitiesResult',
            'ArrayOfPayerEntityInfo' => '\\ArrayType\\ArrayOfPayerEntityInfo',
            'PayerEntityInfo' => '\\StructType\\PayerEntityInfo',
            'GetPayeeInvoiceFile' => '\\StructType\\GetPayeeInvoiceFile',
            'GetPayeeInvoiceFileResponse' => '\\StructType\\GetPayeeInvoiceFileResponse',
            'GetInvoiceFileResult' => '\\StructType\\GetInvoiceFileResult',
        );
    }
}
