<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateOrUpdateCustomFieldValue StructType
 * @subpackage Structs
 */
class CreateOrUpdateCustomFieldValue extends AbstractStructBase
{
    /**
     * The timestamp
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $timestamp;
    /**
     * The payerName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $payerName;
    /**
     * The key
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $key;
    /**
     * The customFieldValueUpdateModel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\TipaltiCustomFieldValue
     */
    public $customFieldValueUpdateModel;
    /**
     * Constructor method for CreateOrUpdateCustomFieldValue
     * @uses CreateOrUpdateCustomFieldValue::setTimestamp()
     * @uses CreateOrUpdateCustomFieldValue::setPayerName()
     * @uses CreateOrUpdateCustomFieldValue::setKey()
     * @uses CreateOrUpdateCustomFieldValue::setCustomFieldValueUpdateModel()
     * @param float $timestamp
     * @param string $payerName
     * @param string $key
     * @param \StructType\TipaltiCustomFieldValue $customFieldValueUpdateModel
     */
    public function __construct($timestamp = null, $payerName = null, $key = null, \StructType\TipaltiCustomFieldValue $customFieldValueUpdateModel = null)
    {
        $this
            ->setTimestamp($timestamp)
            ->setPayerName($payerName)
            ->setKey($key)
            ->setCustomFieldValueUpdateModel($customFieldValueUpdateModel);
    }
    /**
     * Get timestamp value
     * @return float
     */
    public function getTimestamp()
    {
        return $this->timestamp;
    }
    /**
     * Set timestamp value
     * @param float $timestamp
     * @return \StructType\CreateOrUpdateCustomFieldValue
     */
    public function setTimestamp($timestamp = null)
    {
        // validation for constraint: float
        if (!is_null($timestamp) && !(is_float($timestamp) || is_numeric($timestamp))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($timestamp, true), gettype($timestamp)), __LINE__);
        }
        $this->timestamp = $timestamp;
        return $this;
    }
    /**
     * Get payerName value
     * @return string|null
     */
    public function getPayerName()
    {
        return $this->payerName;
    }
    /**
     * Set payerName value
     * @param string $payerName
     * @return \StructType\CreateOrUpdateCustomFieldValue
     */
    public function setPayerName($payerName = null)
    {
        // validation for constraint: string
        if (!is_null($payerName) && !is_string($payerName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($payerName, true), gettype($payerName)), __LINE__);
        }
        $this->payerName = $payerName;
        return $this;
    }
    /**
     * Get key value
     * @return string|null
     */
    public function getKey()
    {
        return $this->key;
    }
    /**
     * Set key value
     * @param string $key
     * @return \StructType\CreateOrUpdateCustomFieldValue
     */
    public function setKey($key = null)
    {
        // validation for constraint: string
        if (!is_null($key) && !is_string($key)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($key, true), gettype($key)), __LINE__);
        }
        $this->key = $key;
        return $this;
    }
    /**
     * Get customFieldValueUpdateModel value
     * @return \StructType\TipaltiCustomFieldValue|null
     */
    public function getCustomFieldValueUpdateModel()
    {
        return $this->customFieldValueUpdateModel;
    }
    /**
     * Set customFieldValueUpdateModel value
     * @param \StructType\TipaltiCustomFieldValue $customFieldValueUpdateModel
     * @return \StructType\CreateOrUpdateCustomFieldValue
     */
    public function setCustomFieldValueUpdateModel(\StructType\TipaltiCustomFieldValue $customFieldValueUpdateModel = null)
    {
        $this->customFieldValueUpdateModel = $customFieldValueUpdateModel;
        return $this;
    }
}
