<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateOrUpdatePaymentTerms StructType
 * @subpackage Structs
 */
class CreateOrUpdatePaymentTerms extends AbstractStructBase
{
    /**
     * The timestamp
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $timestamp;
    /**
     * The payerName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $payerName;
    /**
     * The key
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $key;
    /**
     * The paymentTerms
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTipaltiPaymentTerm
     */
    public $paymentTerms;
    /**
     * Constructor method for CreateOrUpdatePaymentTerms
     * @uses CreateOrUpdatePaymentTerms::setTimestamp()
     * @uses CreateOrUpdatePaymentTerms::setPayerName()
     * @uses CreateOrUpdatePaymentTerms::setKey()
     * @uses CreateOrUpdatePaymentTerms::setPaymentTerms()
     * @param float $timestamp
     * @param string $payerName
     * @param string $key
     * @param \ArrayType\ArrayOfTipaltiPaymentTerm $paymentTerms
     */
    public function __construct($timestamp = null, $payerName = null, $key = null, \ArrayType\ArrayOfTipaltiPaymentTerm $paymentTerms = null)
    {
        $this
            ->setTimestamp($timestamp)
            ->setPayerName($payerName)
            ->setKey($key)
            ->setPaymentTerms($paymentTerms);
    }
    /**
     * Get timestamp value
     * @return float
     */
    public function getTimestamp()
    {
        return $this->timestamp;
    }
    /**
     * Set timestamp value
     * @param float $timestamp
     * @return \StructType\CreateOrUpdatePaymentTerms
     */
    public function setTimestamp($timestamp = null)
    {
        // validation for constraint: float
        if (!is_null($timestamp) && !(is_float($timestamp) || is_numeric($timestamp))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($timestamp, true), gettype($timestamp)), __LINE__);
        }
        $this->timestamp = $timestamp;
        return $this;
    }
    /**
     * Get payerName value
     * @return string|null
     */
    public function getPayerName()
    {
        return $this->payerName;
    }
    /**
     * Set payerName value
     * @param string $payerName
     * @return \StructType\CreateOrUpdatePaymentTerms
     */
    public function setPayerName($payerName = null)
    {
        // validation for constraint: string
        if (!is_null($payerName) && !is_string($payerName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($payerName, true), gettype($payerName)), __LINE__);
        }
        $this->payerName = $payerName;
        return $this;
    }
    /**
     * Get key value
     * @return string|null
     */
    public function getKey()
    {
        return $this->key;
    }
    /**
     * Set key value
     * @param string $key
     * @return \StructType\CreateOrUpdatePaymentTerms
     */
    public function setKey($key = null)
    {
        // validation for constraint: string
        if (!is_null($key) && !is_string($key)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($key, true), gettype($key)), __LINE__);
        }
        $this->key = $key;
        return $this;
    }
    /**
     * Get paymentTerms value
     * @return \ArrayType\ArrayOfTipaltiPaymentTerm|null
     */
    public function getPaymentTerms()
    {
        return $this->paymentTerms;
    }
    /**
     * Set paymentTerms value
     * @param \ArrayType\ArrayOfTipaltiPaymentTerm $paymentTerms
     * @return \StructType\CreateOrUpdatePaymentTerms
     */
    public function setPaymentTerms(\ArrayType\ArrayOfTipaltiPaymentTerm $paymentTerms = null)
    {
        $this->paymentTerms = $paymentTerms;
        return $this;
    }
}
