<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TipaltiInvoiceItemResult StructType
 * @subpackage Structs
 */
class TipaltiInvoiceItemResult extends AbstractStructBase
{
    /**
     * The Succeeded
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Succeeded;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * The InvoiceRefCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InvoiceRefCode;
    /**
     * Constructor method for TipaltiInvoiceItemResult
     * @uses TipaltiInvoiceItemResult::setSucceeded()
     * @uses TipaltiInvoiceItemResult::setErrorMessage()
     * @uses TipaltiInvoiceItemResult::setInvoiceRefCode()
     * @param bool $succeeded
     * @param string $errorMessage
     * @param string $invoiceRefCode
     */
    public function __construct($succeeded = null, $errorMessage = null, $invoiceRefCode = null)
    {
        $this
            ->setSucceeded($succeeded)
            ->setErrorMessage($errorMessage)
            ->setInvoiceRefCode($invoiceRefCode);
    }
    /**
     * Get Succeeded value
     * @return bool
     */
    public function getSucceeded()
    {
        return $this->Succeeded;
    }
    /**
     * Set Succeeded value
     * @param bool $succeeded
     * @return \StructType\TipaltiInvoiceItemResult
     */
    public function setSucceeded($succeeded = null)
    {
        // validation for constraint: boolean
        if (!is_null($succeeded) && !is_bool($succeeded)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($succeeded, true), gettype($succeeded)), __LINE__);
        }
        $this->Succeeded = $succeeded;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \StructType\TipaltiInvoiceItemResult
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
    /**
     * Get InvoiceRefCode value
     * @return string|null
     */
    public function getInvoiceRefCode()
    {
        return $this->InvoiceRefCode;
    }
    /**
     * Set InvoiceRefCode value
     * @param string $invoiceRefCode
     * @return \StructType\TipaltiInvoiceItemResult
     */
    public function setInvoiceRefCode($invoiceRefCode = null)
    {
        // validation for constraint: string
        if (!is_null($invoiceRefCode) && !is_string($invoiceRefCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoiceRefCode, true), gettype($invoiceRefCode)), __LINE__);
        }
        $this->InvoiceRefCode = $invoiceRefCode;
        return $this;
    }
}
